// Defines the array structure of a shape
#define TMF_SHAPE_CENTER 0
#define TMF_SHAPE_WIDTH 1
#define TMF_SHAPE_HEIGHT 2
#define TMF_SHAPE_ANGLE 3
#define TMF_SHAPE_RECTANGLE 4


// Defines the array structure for the spawned items in Random Spawn like Convoys, roadblocks, etc.
#define TMF_SPAWN_ARRAY_SECTOR 0
#define TMF_SPAWN_ARRAY_SPAWNTIME 1
#define TMF_SPAWN_ARRAY_STARTPOS 2
#define TMF_SPAWN_ARRAY_OBJECTNAME 3
#define TMF_SPAWN_ARRAY_RADIUS 4
#define TMF_SPAWN_ARRAY_GROUP 5
#define TMF_SPAWN_ARRAY_UNITSARRAY 6
#define TMF_SPAWN_ARRAY_OBJECTSARRAY 7
#define TMF_SPAWN_ARRAY_MARKERSARRAY 8

// The structure of the sectors array
#define TMF_SECTOR_ARRAY_TYPE 0
#define TMF_SECTOR_ARRAY_SHAPE_ARRAY 1
#define TMF_SECTOR_ARRAY_DISPLAY_NAME 2
#define TMF_SECTOR_ARRAY_UNIQUE_NAME 3

#define TMF_SECTOR_TYPE_MISSIONS 0
#define TMF_SECTOR_TYPE_SPAWN 1

// The structure of the map locations array
#define TMF_MAP_LOCATION_CENTER 0
#define TMF_MAP_LOCATION_DISPLAYNAME 1
#define TMF_MAP_LOCATION_UNIQUENAME 2
#define TMF_MAP_LOCATION_SIZE 3
#define TMF_MAP_LOCATION_TYPE 4
#define TMF_MAP_LOCATION_MISSIONSECTOR 5
#define TMF_MAP_LOCATION_CIVILDENSITY 6
#define TMF_MAP_LOCATION_ROADBLOCK 7
#define TMF_MAP_LOCATION_AEGSECTION 8

#define TMF_MAP_LOCATION_TYPE_TOWN 0
#define TMF_MAP_LOCATION_TYPE_VILLAGE 1
#define TMF_MAP_LOCATION_TYPE_LONELY 2
#define TMF_MAP_LOCATION_TYPE_SPECIAL 3
#define TMF_MAP_LOCATION_TYPE_MILITARY 4
#define TMF_MAP_LOCATION_TYPE_INDUSTRIAL 5
#define TMF_MAP_LOCATION_TYPE_GRASSLAND 6
#define TMF_MAP_LOCATION_TYPE_FOREST 7
#define TMF_MAP_LOCATION_TYPE_BEACH 8
#define TMF_MAP_LOCATION_TYPE_ISLAND 9
#define TMF_MAP_LOCATION_TYPE_MOUNTAIN 10
#define TMF_MAP_LOCATION_TYPE_AIRPORT 11

// The positions in the array of vehicle types
#define TMF_VEHICLE_TYPES_TANK 0
#define TMF_VEHICLE_TYPES_HEAVYAPC 1
#define TMF_VEHICLE_TYPES_LIGHTAPC 2
#define TMF_VEHICLE_TYPES_TRUCKS 3
#define TMF_VEHICLE_TYPES_HEAVYWHEEL 4
#define TMF_VEHICLE_TYPES_LIGHTWHEEL 5
#define TMF_VEHICLE_TYPES_STATIC 6
#define TMF_VEHICLE_TYPES_STATICAA 7
#define TMF_VEHICLE_TYPES_ARTILLERY 8
#define TMF_VEHICLE_TYPES_FUEL 9
#define TMF_VEHICLE_TYPES_REPAIR 10
#define TMF_VEHICLE_TYPES_AMMO 11
#define TMF_VEHICLE_TYPES_TRANSPORT 12
#define TMF_VEHICLE_TYPES_CHOPPERS 13
#define TMF_VEHICLE_TYPES_AIRTRANS 14


// The building positions array
#define TMF_BUILDING_POS_COMBAT 0
#define TMF_BUILDING_POS_HIDE 1
#define TMF_BUILDING_POS_SNIPER 2
#define TMF_BUILDING_POS_VEHICLE 2


// The soldier types
#define TMF_UNIT_TYPES_NORMAL 0
#define TMF_UNIT_TYPES_SPECIAL_FORCE 1
#define TMF_UNIT_TYPES_SNIPER 2


// Mission characters array
#define TMF_MISSION_CHAR_CIVILIAN_WOMEN 0
#define TMF_MISSION_CHAR_CIVILIAN_MEN 1
#define TMF_MISSION_CHAR_CIVILIAN_OFFICIAL 2
#define TMF_MISSION_CHAR_CIVILIAN_CRIMINAL 3
#define TMF_MISSION_CHAR_MILITARY_OFFICER 4
#define TMF_MISSION_CHAR_MILITARY_PILOT 5
#define TMF_MISSION_CHAR_MILITARY_CREW 6
#define TMF_MISSION_CHAR_MILITARY_SOLDIER 7
#define TMF_MISSION_CHAR_SPY 8
#define TMF_MISSION_CHAR_INFORMER 9
