
/* ACV_FNCT_ied.sqf
-----------------------------------------------------------------------------
Positionne un IED avec différents paramètres réglables :
Side visée, objet ou position, distance déclenchement, objet ou classe de l'IED, munition, fiabilité, complexité

Exemple :
[west,ACV_PosClick,30,"Land_IED_v2_PMC","R_57mm_HE",1,0] call ACV_FNCT_IED;
[east,OBJ,50,OBJ,"ARTY_Sh_81_WP",0.7,0.5] call ACV_FNCT_IED;

function ACV_FNCT_IED()

@param0 Side visée.
@param1 variant position de l'IED.
@param2 nombre: (optionnel) Défaut : 15
@param3 classe ou objet : (optionnel) Défaut : "Land_IED_v2_PMC"
@param4 chaîne : (optionnel) Défaut : "R_57mm_HE"
@param5 nombre : (optionnel) Défaut : 1 - fiabilité de 0 à 1
@param6 nombre : (optionnel) Défaut : 0 - complexité de 0 à 1

variant = 	(string) pseudo de joueur (la position du joueur sera renvoyée)
			(group) un group (la position du leader sera renvoyée)
			(Object) un objet quelquonque (la position de l'objet sera renvoyée)
			(array) position (tableau [x, y, z])
@return Rien

Objet visuel IED - exemple : "Land_IED_v1_PMC","Land_IED_v2_PMC","Land_IED_v3_PMC","Mine","Explosive","bomb"
Munition :
	"R_57mm_HE"
	"SH_105_HE"
	"SH_120_HE"
	"SH_125_HE"
	"SH_155_HE"
	"M_Sidewinder_AA"
	"Bo_GBU12_LGB"
	"Bo_FAB_250"
	"ARTY_Sh_82_HE"
	"ARTY_Sh_82_WP"
	"ARTY_Sh_122_WP"
	"ARTY_Sh_122_HE"
	"ARTY_R_227mm_HE"
	"ARTY_SmokeShellWhite"
	"ARTY_Sh_122_SMOKE"
	"ARTY_Sh_81_ILLUM"
	"ARTY_Sh_122_ILLUM"
----------------------------------------------------------------------------*/
#include "ACV_constantes.h"
ACV_FNCT_IED = {
	private "_code";
	_code = compile "_this spawn R3F_FNCT_IED;";
	[ACV_BROADCAST_TO_SERVER,_code,_this] call ACV_FNCT_BroadcastCode;
};
