
/* ACV_FNCT_bomber.sqf
-----------------------------------------------------------------------------
La fonction s'appelle en passant les paramètres suivants :
- Type de bombe (avec les guillemets)
- Position du bombardement (Tableau [x,y,z])
- Rayon en mètres
- Durée en secondes
- Fréquence des explosions en secondes

Type de bombes :
	"R_57mm_HE"
	"SH_105_HE"
	"SH_120_HE"
	"SH_125_HE"
	"SH_155_HE"
	"M_Sidewinder_AA"
	"Bo_GBU12_LGB"
	"Bo_FAB_250"
	"ARTY_Sh_82_HE"
	"ARTY_Sh_82_WP"
	"ARTY_Sh_122_WP"
	"ARTY_Sh_122_HE"
	"ARTY_R_227mm_HE"
	"ARTY_SmokeShellWhite"
	"ARTY_Sh_122_SMOKE"
	"ARTY_Sh_81_ILLUM"
	"ARTY_Sh_122_ILLUM"

Exemple : ["Bo_Gbu12_Lgb", [0,0,0], 200, 30, 5] call ACV_FNCT_Bomber;

Bombardement de GBU sur la position de OBJ1 et dans un rayon de 200m autour
pour une durée de 30 secondes avec des impacts toutes les 5 secondes

function ACV_FNCT_Bomber()

@param string Type de bombes
@param array Position initiale du bombardement
@param int Rayon du bombardement
@param int Durée du bombardement
@param int Fréquence des explosion (densité)

@return int Le nombre de bombes explosées
----------------------------------------------------------------------------*/
#include "ACV_constantes.h"
ACV_FNCT_Bomber = {
	private "_code";
	_code = compile "_this call R3F_FNCT_Bomber;";
	// diag_log Format["Server Bomber: %1 - %2", _code, _this];
	[ACV_BROADCAST_TO_SERVER,_code,_this] call ACV_FNCT_BroadcastCode;
};