#include "ACV_constantes.h"

	/* Burning vehicles. By Maddmatt, for ArmA 2
	How to use
	[unit,intensity,time,lifecheck,fade] spawn BIS_Effects_Burn

	unit: the name of the object that the fire will be attached to
	intensity: the intensity of the fire. Recommended to use values between 0.7 and 10, higher values may be used if desired though.
	time: the time that the fire started. use global variable "time". this is used to keep effects synced for JIP players
	lifecheck: if this is true then the unit will only burn as ling as it is dead (!alive unit). set to false to burn things like buildings and gamelogics
	fade: if true then the fire will die down over time, eventually dying out. set to false if you want it to keep burning. (affected by rain too).

	If you want to kill a fire you can delete the object it is attached to.
	hint: you can attach a gamelogic to a moving object via the attachto command, and then make the gamelogic burn.
	that way you can kill the fire without deleting the object.

	examples:
	To make a gamelogic named mygamelogic burn forever with a big fire:
	[mygamelogic,10,time,false,false] spawn BIS_Effects_Burn

	same with medium sized fire:
	[mygamelogic,5,time,false,false] spawn BIS_Effects_Burn

	To make a gamelogic burn and have the fire fade over time:
	[mygamelogic,10,time,false,true] spawn BIS_Effects_Burn

	To make it smoke, with no visible flame you can use an intensity of 3 or lower:
	[mygamelogic,3,time,false,false] spawn BIS_Effects_Burn */

	/* Initialise la fonction (revu par Xeno) sur les joueurs, BIS_Effects_Burn = compile preprocessFile "tmf\core\modules\r3f_acv\Scripts\EFFECT_burn.sqf";
	 la place de celle de BIS (bug des flammes en JIP ???) BIS_Effects_Burn = compile preprocessFile "\ca\Data\ParticleEffects\SCRIPTS\destruction\burn.sqf"; */
ACV_FNCT_Broadcast_BIS_Effects_Burn = {
	private ["_param","_logic","_pos","_intensity","_temp","_lifecheck","_fade","_grp","_logic","_effet","_temp"];
	_param = _this select 0;
	if (typeName _param == "ARRAY") then {_logic = true;_pos = _param;};
	if (typeName _param == "OBJECT") then {_logic = false;};
	if (isNil "_logic") exitWith {};
	_intensity = if (count _this > 1) then {_this select 1;} else {5;};
	if (typeName _intensity != "SCALAR") exitWith {};
	_temp = if (count _this > 2) then {_this select 2;} else {10;};
	if (typeName _temp != "SCALAR") exitWith {};
	_lifecheck = if (count _this > 3) then {_this select 3;} else {false;};
	if (typeName _lifecheck != "BOOL") exitWith {};
	_fade = if (count _this > 4) then {_this select 4;} else {false;};
	if (typeName _fade != "BOOL") exitWith {};
	if (_logic) then {
		_grp = createGroup sideLogic;
		_param = _grp createUnit ["Logic",_pos,[],0,"NONE"];
		_param setPos _pos;
	};
	[_param,_intensity,_temp,_lifecheck,_fade] spawn {
		private "_code";
		_code = compile "_this spawn BIS_Effects_Burn;";
		[ACV_BROADCAST_TO_CLIENT,_code,_this] call ACV_FNCT_BroadcastCode;
	};
	if (_logic) then {
		sleep _temp + 5;
		deleteVehicle _param;
		sleep 2;
		deleteGroup _grp;
	};
};

/*
if !(isServer && isDedicated) then {
};
*/

if (isServer) then {
	R3F_FNCT_Explo = {
		private ["_class","_item","_pos","_explo"];
		_class = _this select 0;
		if (typeName _class != "STRING") exitWith {};
		_item = _this select 1;
		if (isNil "_item") exitWith {};
		_pos = [_item] call R3F_FNCT_GetPos;
		if (count _pos == 0) exitWith {};
		_explo = createVehicle [_class,_pos,[],0,"NONE"];
		_explo setdammage 1;
		sleep 5;
		deleteVehicle _explo;
	};
	R3F_FNCT_Fumi = {
		private ["_class","_item","_pos","_z","_temp","_fumi"];
		_class = _this select 0;
		if (typeName _class != "STRING") exitWith {};
		_item = _this select 1;
		if (isNil "_item") exitWith {};
		_pos = [_item] call R3F_FNCT_GetPos;
		if (count _pos == 0) exitWith {};
		_z = if (count _this > 2) then {_this select 2;} else {0;};
		_temp = if (count _this > 3) then {_this select 3;} else {10;};
		_fumi = createVehicle [_class,_pos,[],0,"NONE"];
		_fumi setPos [_pos select 0,_pos select 1,_z];
		sleep _temp;
		deleteVehicle _fumi;
	};
};
