
/* ACV_FNCT_Azimut.sqf
-----------------------------------------------------------------------------
La fonction s'appelle en passant comme paramètres :
le nom/object/group initial et le nom/obj/group final
la fonction renvoi l'azimut entre les deux

Exemple :
_azimut = ["Clint", "BeTeP"] call R3F_FNCT_Azimut;
Renvoi l'azimut que Clint doit prendre pour rejoindre BeTeP

_azimut = ["BeTeP", OBJ1] call R3F_FNCT_Azimut;
Renvoi l'azimut que BeTeP doit prendre pour rejoindre l'objet OBJ1

[GRP1, GRP2] call R3F_FNCT_Azimut;
Renvoi l'azimut que le leader du groupe GRP1 doit prendre pour rejoindre le groupe GRP2

function R3F_FNCT_Azimut()

@param variant Position de l'objet initial
@param variant Position de l'objet de destinatation

@return int azimut en degrés entre les deux entités (-1 en cas d'erreur)

variant = 	(string) nom de joueur (la position du joueur sera renvoyée)
			(group) un group (la position du leader sera renvoyée)
			(Object) un objet quelquonque (la position de l'objet sera renvoyée)
			(array) position (tableau [x, y, z])

références  :
http://community.bistudio.com/wiki/getPos
http://community.bistudio.com/wiki/typeName
http://community.bistudio.com/wiki/leader
http://community.bistudio.com/wiki/atan2
----------------------------------------------------------------------------*/
