#include <crbprofiler.hpp>

private ["_update_rate"];
_update_rate = 30; //minimum 30 seconds

// do not edit below this

if (isserver) then {    
		MP_rights_list = [];
		diag_log format["MSO-%1 RMM MP RIGHTS: %2, %3", time, _update_rate, mprightsInternalFile];
       
        [_update_rate] spawn {
                private ["_uid","_server_file","_update_rate","_contents","_name","_rank"];
				_server_file = "mso\mso_uids.sqf"; //File path relative to ArmA2 directory
				_contents = call compile preprocessFileLineNumbers _server_file;
				if (isNil "_contents") then {
					diag_log format["MSO-%1 RMM MP RIGHTS: Missing mprights file, %2",time, isNil "_contents"];
				} else {
					diag_log format["MSO-%1 RMM MP RIGHTS: %2", time, _contents];
				};
                _update_rate = _this select 0;
                while{true} do {
                        CRBPROFILERSTART("MP Rights")
		
                        if(isNil "_contents") exitWith {
								MSO_R_Names = [];
                                // MSO_R_Admin = [""];
                                // MSO_R_Moderator = [""];
                                // MSO_R_Member = [""];
								// MSO_R_Recruit = [""];
                                // MSO_R_Leader = [""];
                                // MSO_R_Officer = [""];
                                // MSO_R_Air = [""];
                                // MSO_R_Crew = [""];
								
								MSO_R_Players = [];
								MSO_R_PlayerRoles = [];
								diag_log format["MSO-%1 RMM MP RIGHTS: No MP Rights. Exiting...", time];
                        };
                        // diag_log format["MSO-%1 RMM MP RIGHTS: Vehicles: %2", time,vehicles];
				        {
							// diag_log format["MSO-%1 RMM MP RIGHTS: Vehicle Test: %2", time,[typeof _x, str _x,_x getVariable "mso_reserved_vec",(_x iskindof "Air"), (_x iskindof "Tank"), (_x iskindof "AllVehicles")]];
							if (_x iskindof "Air") then {
								if (_x getVariable "mso_reserved_vec" && isnil {_x getVariable "mso_reserved_event"}) then {
									_x setVariable ["mso_reserved_event",(_x addEventhandler ["GetIn", {[_this,{[(getPlayerUID player),["air","member","admin"]] call mp_rights_fnc_hasRoles}] execFSM "tmf\core\scripts\rmm_mp_rights\vehicledrivercheck.fsm"}])];
									diag_log format["MSO-%1 RMM MP RIGHTS: Air: %2", time,[typeof _x, str _x]];
								};
							};
							if (_x iskindof "Tank") then {
								if (_x getVariable "mso_reserved_vec" && isnil {_x getVariable "mso_reserved_event"}) then {
									_x setVariable ["mso_reserved_event",(_x addEventhandler ["GetIn", {[_this,{[(getPlayerUID player),["crew","member","admin"]] call mp_rights_fnc_hasRoles}] execFSM "tmf\core\scripts\rmm_mp_rights\vehicledrivercheck.fsm"}])];
									diag_log format["MSO-%1 RMM MP RIGHTS: Tank: %2", time,[typeof _x, str _x]];
								};
							};
							if (_x iskindof "AllVehicles") then {
								if (_x getVariable "mso_reserved_vec" && isnil {_x getVariable "mso_reserved_event"}) then {
									_x setVariable ["mso_reserved_event",(_x addEventhandler ["GetIn", {[_this,{[(getPlayerUID player)] call mp_rights_fnc_isRecruit}] execFSM "tmf\core\scripts\rmm_mp_rights\vehicledrivercheck.fsm"}])];
									diag_log format["MSO-%1 RMM MP RIGHTS: Vehicle: %2", time,[typeof _x, str _x]];
								};
							};
						} foreach vehicles;
                        
						
                        if (!([_contents, MP_rights_list] call BIS_fnc_areEqual)) then {
                                MP_rights_list = _contents;
								MSO_R_Names = [];
                                // MSO_R_Admin = [];
                                // MSO_R_Moderator = [];
                                // MSO_R_Member = [];
                                // MSO_R_Recruit = [];
                                // MSO_R_Leader = [];
                                // MSO_R_Officer = [];
                                // MSO_R_Air = [];
                                // MSO_R_Crew = [];
								
								MSO_R_Players = [];
								MSO_R_PlayerRoles = [];
                                {
                                        _uid = _x select 0;
										_rank = toupper(_x select 1);
                                        MSO_R = _x select 2;
										_name = "";
										if (count _x > 3) then {
											_name = toupper(_x select 3);
											MSO_R_Names set [count MSO_R_Names, [_name,_uid]];
										};
										// The fact you are present in the list makes you part of recruit, it's the minimum rights
                                        // MSO_R_Recruit set [count MSO_R_Recruit, _uid];
                                        // if ("admin" in MSO_R) then {
                                                // MSO_R_Admin set [count MSO_R_Admin, _uid];
                                        // } else {
                                                // MSO_R_Admin = MSO_R_Admin  - [_uid];
                                        // };
                                        // if ("moderator" in MSO_R) then {
                                                // MSO_R_Moderator set [count MSO_R_Moderator, _uid];
                                        // } else {
                                                // MSO_R_Moderator = MSO_R_Moderator  - [_uid];
                                        // };
                                        // if ("member" in MSO_R || "admin" in MSO_R) then {
                                                // MSO_R_Member set [count MSO_R_Member, _uid];
                                        // } else {
                                                // MSO_R_Member = MSO_R_Member  - [_uid];
                                        // };
                                        // if (_rank in ["CORPORAL","SERGEANT","LIEUTENANT","CAPTAIN","COMMANDER"] || "admin" in MSO_R) then {
                                                // MSO_R_Leader set [count MSO_R_Leader, _uid];
                                        // } else {
                                                // MSO_R_Leader = MSO_R_Leader  - [_uid];
                                        // };
                                        // if (_rank in ["LIEUTENANT","CAPTAIN","COMMANDER"] || "admin" in MSO_R) then {
                                                // MSO_R_Officer set [count MSO_R_Officer, _uid];
                                        // } else {
                                                // MSO_R_Officer = MSO_R_Officer  - [_uid];
                                        // };
                                        // if ("pilot" in MSO_R || "admin" in MSO_R) then {
                                                // MSO_R_Air set [count MSO_R_Air, _uid];
                                        // } else {
                                                // MSO_R_Air = MSO_R_Air  - [_uid];
                                        // };
                                        // if ("crew" in MSO_R || "admin" in MSO_R) then {
                                                // MSO_R_Crew set [count MSO_R_Crew, _uid];
                                        // } else {
                                                // MSO_R_Crew = MSO_R_Crew  - [_uid];
                                        // };
										
										// Only keep this and the names
                                        MSO_R_Players set [count MSO_R_Players, _uid];
										_roles = [];
                                        if (_rank in ["SERGEANT","LIEUTENANT","CAPTAIN","COMMANDER","COLONEL","GENERAL"]) then {
                                                _roles set [count _roles, tolower("leader")];
                                        };
                                        if (_rank in ["LIEUTENANT","CAPTAIN","COMMANDER","COLONEL","GENERAL"]) then {
                                                _roles set [count _roles, tolower("officer")];
                                        };
                                        if (_rank in ["COLONEL","GENERAL"]) then {
                                                _roles set [count _roles, tolower("highcommand")];
                                        };
										{
											_roles set [count _roles, tolower(_x)];
										} foreach MSO_R;
										MSO_R_PlayerRoles set [count MSO_R_PlayerRoles, _roles];
                                } foreach MP_rights_list;
								publicVariable "MSO_R_Names";
                                // publicVariable "MSO_R_Admin";
                                // publicVariable "MSO_R_Moderator";
                                // publicVariable "MSO_R_Member";
                                // publicVariable "MSO_R_Recruit";
                                // publicVariable "MSO_R_Leader";
                                // publicVariable "MSO_R_Officer";
                                // publicVariable "MSO_R_Air";
                                // publicVariable "MSO_R_Crew";
								
                                publicVariable "MSO_R_Players";
                                publicVariable "MSO_R_PlayerRoles";
                                if (debug_mso) then {
									// diag_log format["MSO-%1 RMM MP RIGHTS: Admin: %2", time, MSO_R_Admin];
									// diag_log format["MSO-%1 RMM MP RIGHTS: Moderator: %2", time, MSO_R_Moderator];
									// diag_log format["MSO-%1 RMM MP RIGHTS: Member: %2", time, MSO_R_Member];
									// diag_log format["MSO-%1 RMM MP RIGHTS: Recruit: %2", time, MSO_R_Recruit];
									// diag_log format["MSO-%1 RMM MP RIGHTS: Air: %2", time, MSO_R_Air];
									// diag_log format["MSO-%1 RMM MP RIGHTS: Crew: %2", time, MSO_R_Crew];
									
									diag_log format["MSO-%1 RMM MP RIGHTS: Players: %2", time, MSO_R_Players];
									diag_log format["MSO-%1 RMM MP RIGHTS: Roles: %2", time, MSO_R_PlayerRoles];
								};

                        };                
                        CRBPROFILERSTOP
                        sleep _update_rate;
                };
        };
};
MSO_R_Locals = [];
if (!isDedicated) then {
	"MSO_R_GrantRight" addPublicVariableEventHandler mp_rights_fnc_pveh;
	[_update_rate] spawn {
		_update_rate = _this select 0;
		waituntil {!isnull player};
		private ["_mp_rights","_update_rate","_local_rights"];
		while{true} do {
			if (isnil "MSO_R_Locals") then { MSO_R_Locals = [] };
			_local_rights = [];
			_mp_rights = player getVariable "MSO_MP_RIGHTS";
			if (!isnil "_mp_rights") then {
				if (typename _mp_rights == typename "") then { _mp_rights = [_mp_rights]; };
				if (typename _mp_rights == typename []) then {
					{
						if (typename _x == typename "") then {
							if (!(_x in MSO_R_Locals)) then {
								_local_rights set [count _local_rights, toLower(_x)];
							};
						};
					} foreach _mp_rights;
				};
			};
			{ MSO_R_Locals set [count MSO_R_Locals, _x];
			} foreach _local_rights;
			if (debug_mso) then {
				diag_log format["MSO-%1 RMM MP RIGHTS: Local Roles: %2", time, MSO_R_Locals];
			};
			sleep (10 + random(7));
		};
	};
};
true;
