respawn = 3;
respawnDelay = 3;
respawnDialog = false;

#include "core\description.hpp"
#include "support\description.hpp"
#include "mission\description.hpp"

class CfgNotifications
{
	class Default
	{
		title = ""; // Tile displayed as text on black background. Filled by arguments.
		iconPicture = ""; // Small icon displayed in left part. Colored by "color", filled by arguments.
		iconText = ""; // Short text displayed over the icon. Colored by "color", filled by arguments.
		description = ""; // Brief description displayed as structured text. Colored by "color", filled by arguments.
		color[] = {1,1,1,1}; // Icon and text color
		duration = 5; // How many seconds will the notification be displayed
		priority = 0; // Priority; higher number = more important; tasks in queue are selected by priority
		difficulty[] = {}; // Required difficulty settings. All listed difficulties has to be enabled
	};
	class TaskCreated
	{
		title = "$STR_TASK_CREATED";
		iconPicture = "\A3\ui_f\data\map\mapcontrol\taskiconcreated_ca.paa";
		color[] = {1,1,1,1};
		description = "%1";
		priority = 10;
	};
	class TaskAssigned
	{
		title = "$STR_TASK_ASSIGNED";
		iconPicture = "\A3\ui_f\data\map\mapcontrol\taskIcon_ca.paa";
		color[] = {1,1,1,1};
		description = "%1";
		priority = 7;
	};
	class TaskSucceeded
	{
		title = "$STR_TASK_SUCCEEDED";
		iconPicture = "\A3\ui_f\data\map\mapcontrol\taskicondone_ca.paa";
		color[] = {0.6,0.84,0.47,1};
		description = "%1";
		priority = 5;
	};
	class TaskFailed
	{
		title = "$STR_TASK_FAILED";
		iconPicture = "\A3\ui_f\data\map\mapcontrol\taskiconfailed_ca.paa";
		color[] = {0.972549,0.121568,0,1};
		description = "%1";
		priority = 3;
	};
	class TaskCanceled
	{
		title = "$STR_TASK_CANCELED";
		iconPicture = "\A3\ui_f\data\map\mapcontrol\taskiconcanceled_ca.paa";
		color[] = {0.75,0.75,0.75,1};
		description = "%1";
		priority = 1;
	};
	
	#include "core\cfgNotifications.hpp"
	#include "support\cfgNotifications.hpp"
	#include "mission\cfgNotifications.hpp"
};