// 2014-10-06 Tyrghen
//---------------------------------------------
// Usage:
//  [] call edt_fnc_fillWithEnemies;
//---------------------------------------------
// Purpose:
// Fills the target zone around the ACV_PosClick with enemy footmen only (and snipers if appropriate).
// 
// Optional Parameters:
// - Zone radius, it defaults to 200m around the given position.
//
// Returns:
// - Nothing, created groups appear in the A.C.V.
//---------------------------------------------
// Objectif:
// Remplit la zone cible autour de l'ACV_PosClick avec de l'infantrie ennemies uniquement (et des snipers si approprié).
//
// Paramètres:
// - Rayon de la zone, par défaut 200m autour de la position donnée.
//
// Renvoie:
// - Rien, les groupes créés apparaîtront dans l'A.C.V.
//---------------------------------------------

//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "acv\fn_fillWithEnemies.sqf"
#include <tmf_constants.h>
#include <tmf_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;

private ["_radius"];
DEFAULT_PARAM(_radius,0,200);

if (!isDedicated && {hasInterface} && {!(isNil "ACV_PosClick")} && {(ACV_PosClick vectorDistance [0,0,0]) > 10}) then {
	[ACV_PosClick, _radius, GVAR(side_enemy) ,QUOTE(EFUNC(fillWithEnemies))] call FFUNC(execHC);
} else {
	ERROR_1("Should be executed on a client computer",_this);
};
//[_obj,_obj_name,_instance_id] spawn FFUNC(exportMissionObject);

TRACE("End");
TMFPROFILERSTOP;