// 2014-03-10 Tyrghen
//---------------------------------------------
// Usage:
//  ["Mon texte à afficher"] call edt_fnc_notification;
//  ["STR_TRANSLATED_TEXT"] call edt_fnc_notification;
//  ["Mon texte à afficher","CREATED"] call edt_fnc_notification;
//  ["STR_TRANSLATED_TEXT","SUCCEEDED"] call edt_fnc_notification;
//---------------------------------------------
// Purpose:
// Displays LOCALLY a notification window to the player.
// This function is not synchronised in JIP! It has to be called on each computer (with a trigger for example).
// 
// Parameters:
// - The text to display in the nofication window or a magic string, starting with STR_ which will be automatically translated.
// Optional Parameters:
// - The type of notification to display among: created, canceled, failed, assigned, succeeded
//
// Returns:
// Nothing
//---------------------------------------------
// Objectif:
// Affiche LOCALEMENT une fenêtre de notification au joueur.
// Cette fonction n'est pas synchronisée en JIP! Il faut l'appeler sur chaque PC (avec un déclencheur par exemple).
//
// Paramètres:
// - Le texte à afficher dans la fenêtre de notification ou une chaîne magique, commençant par STR_ qui sera traduite automatiquement.
// Paramètres Optionnels:
// - Le type de notification à afficher parmi: created, canceled, failed, assigned, succeeded
//
// Renvoie:
// Rien
//---------------------------------------------

//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#include <tmf_constants.h>
#include <tmf_macros.h>
#define __THIS_FILE__ "editor\fn_notification.sqf"

// No sense for the server to show a notification
if (isDedicated) exitWith{};

TRACE_1("Start",_this);
TMFPROFILERSTART;

private ["_display","_type"];
DEFAULT_PARAM(_display,0,"");
DEFAULT_PARAM(_type,1,"");

_display = _display call FFUNC(translate);
if (_display != "") then {
	[_display,_type] call FFUNC(notification);
};

TRACE("End");
TMFPROFILERSTOP;