//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "event\fn_eventObjectiveArrestFailed.sqf"
#include <tmf_constants.h>
#include <tmf_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;

if (isServer) then {
	private ["_object","_killer","_action","_parameters","_arrested_msg","_die_msg","_shared_arrested","_shared_alive","_arrested_code","_die_code","_destination","_evt_idx"];
	DEFAULT_PARAM(_params,0,[]);
	DEFAULT_PARAM(_action_id,1,-1);
	
	_object = GETVAL(_params,0,objNull);
	_killer = GETVAL(_params,1,objNull);
	if (!isnull _object) then {
		_action = [_object,_action_id] call FFUNC(actionGet);
		TRACE_1("Action",_action);
		_parameters = [_action] call FFUNC(actionGetParams);
		_instance_id = [_object] call FFUNC(getInstanceID);
		_status = [_object,_action,"LEAD_KILLED_STATUS",-1] call FFUNC(actionGetLocal);
		if (!isNil "_status" && _status < 0) then {
			[_object,_action,"LEAD_KILLED_STATUS",1] call FFUNC(actionSetLocal);
			
			_arrested_msg = [_parameters, "ARREST_MSG", "",THIS_FILE] call FFUNC(hashGet);
			_die_msg = [_parameters, "DIE_MSG", "",THIS_FILE] call FFUNC(hashGet);
			_shared_arrested = [_parameters, "SHARED_ARREST_VAR", "",THIS_FILE] call FFUNC(hashGet);
			_shared_alive = [_parameters, "SHARED_ALIVE_VAR", "",THIS_FILE] call FFUNC(hashGet);
			_arrested_code = [_parameters, "ARREST_CODE", "",THIS_FILE] call FFUNC(hashGet);
			_die_code = [_parameters, "DIE_CODE", "",THIS_FILE] call FFUNC(hashGet);
			if (typename _arrested_msg == typename "") then {_arrested_msg = [_arrested_msg];};
			if (typename _die_msg == typename "") then {_die_msg = [_die_msg];};
			_shared_arrested = _shared_arrested call FFUNC(getStringVar);
			_shared_alive = _shared_alive call FFUNC(getStringVar);

			_evt_idx = [_object,_action,"ARREST_KILLED_EVENT",-1] call FFUNC(actionGetLocal);
			If (!isNil "_evt_idx" && _evt_idx >= 0) then {
				_object removeEventHandler ["killed",_evt_idx];
				TRACE_2("Removed Event",_evt_idx,"ARREST_KILLED_EVENT");
				[_object,_action,"ARREST_KILLED_EVENT",-1] call FFUNC(actionSetLocal);
			};
			if (!isNil "_die_msg") then {
				if (count _die_msg > 0) then {[QGVAR(all_message),[_die_msg,"all",objNull,"hq"],THIS_FILE] call FFUNC(callEvent);};
			};
			if (!isNil "_shared_arrested") then {
				if (_shared_arrested != "") then {
					[_instance_id,_shared_arrested,false] spawn FFUNC(setMissionJIPVar);
					[QGVAR(all_var), [_instance_id,_shared_arrested,false],THIS_FILE] call FFUNC(callEvent);
				};
			};
			if (!isNil "_shared_alive") then {
				if (_shared_alive != "") then {
					[_instance_id,_shared_alive,alive _object] spawn FFUNC(setMissionJIPVar);
					[QGVAR(all_var), [_instance_id,_shared_alive,alive _object],THIS_FILE] call FFUNC(callEvent);
				};
			};
			if (_die_code != "") then {
				[QGVAR(all_execute),[_die_code,_object,_action],THIS_FILE] call FFUNC(callEvent);
			};
		};
	};
} else {
	[QGVAR(s_execute),[QUOTE(FFUNC(eventObjectiveArrestFailed)),_this],THIS_FILE] call FFUNC(callEvent);
	_evt_idx = [_object,_action,"ARREST_KILLED_EVENT",-1] call FFUNC(actionGetLocal);
	if (!isNil "_evt_idx" && _evt_idx >= 0) then {
		_object removeEventHandler ["killed", _evt_idx];
		[_object,_action,"ARREST_KILLED_EVENT",-1] call FFUNC(actionSetLocal);
	};
};
TRACE("End");
TMFPROFILERSTOP;