//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "server\fn_serverExecutePickup.sqf"
#include <tmf_constants.h>
#include <tmf_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;

private ["_object","_action","_parameters","_item_desc","_action_title","_pickup_msg","_shared_variable","_shared_variable_value","_pickup_code","_player","_obj_var_picked","_act_args","_i","_marker"];
DEFAULT_PARAM(_object,TMF_EXECUTE_ACTION_OBJECT,objNull);
DEFAULT_PARAM(_caller,TMF_EXECUTE_ACTION_CALLER,objNull);
DEFAULT_PARAM(_act_id,TMF_EXECUTE_ACTION_ID,-1);
DEFAULT_PARAM(_arguments,TMF_EXECUTE_ACTION_ARGS,[]);
DEFAULT_PARAM(_action,TMF_EXECUTE_ACTION_ACTION,[]);

_action_id = _arguments select TMF_EXECUTE_ACTION_PARAM_ACTID;

if (!isnull _object) then {
	if (_action_id > 0) then {
		_instance_id = [_object] call FFUNC(getInstanceID);
		if (count _action  <= 0) then {
			_action = [_object,_action_id] call FFUNC(actionGet);
		};
		TRACE_1("Action",_action);
		_parameters = [_action] call FFUNC(actionGetParams);
		
		_obj_var = format["mission_object_pickup_player_%1",_action_id];
		_player = OGETVAR(_object,_obj_var,objNull);
		if (isnull _player) then {
			OSETVARP(_object,_obj_var,_caller);
			_player = _caller;
			_item_desc = [_parameters, "ITEM_DESC", ([_object] call FFUNC(displayName)),THIS_FILE] call FFUNC(hashGet);
			_pickup_msg = [_parameters, "PICKUP_MSG", [],THIS_FILE] call FFUNC(hashGet);
			_shared_variable = [_parameters, "SHARED_VAR", "",THIS_FILE] call FFUNC(hashGet);
			_initial_status = false; //[_parameters, "SHARED_VAR_VAL", false,THIS_FILE] call FFUNC(hashGet);
			_action_title = [_parameters, "PICKUP_TITLE", "STR_TMF_PICKUP_DEFACTION",THIS_FILE] call FFUNC(hashGet);
			_pickup_code = [_parameters, "PICKUP_CODE", "",THIS_FILE] call FFUNC(hashGet);
			_shared_variable = _shared_variable call FFUNC(getStringVar);

			_is_picked_up = !_initial_status;
			_obj_var_picked = format["mission_object_pickedup_%1",_action_id];
			OSETVARP(_object,_obj_var_picked,_is_picked_up);
			
			if (IS_STRING(_pickup_msg)) then {
				if (_pickup_msg != "") then { _pickup_msg = [_pickup_msg]; } else { _pickup_msg = []; };
			} else {
				_pickup_msg = +_pickup_msg;
			};
			for "_i" from 0 to ((count _pickup_msg) - 1) step 1 do {
				if (IS_STRING((_pickup_msg select _i))) then {
					if ((_pickup_msg select _i) == TMF_SR_ACTION_CALLER) then {
						_pickup_msg set [_i, ([_caller,"STR_TMF_APLAYER"] call FFUNC(playerName))];
					};
				};
			};
			
			// We delete the object temporary marker if any
			_marker = OGETVAR(_object,"mission_object_pickup_marker","");
			if (IS_MARKER(_marker)) then {
				[[_marker],_instance_id] call FFUNC(marker);
				OSETVAR(_object,"mission_object_pickup_marker","");
			};
			
			If (count _pickup_msg > 0) then {[QGVAR(all_message),[_pickup_msg,"all",objNull,"hq"],THIS_FILE] call FFUNC(callEvent);};

			if (!isNil "_shared_variable") then {
				if (_shared_variable != "") then {
					[_instance_id,_shared_variable,_is_picked_up] spawn FFUNC(setMissionJIPVar);
					[QGVAR(all_var), [_instance_id,_shared_variable,_is_picked_up],THIS_FILE] call FFUNC(callEvent);
				};
			};
			if (_pickup_code != "") then {
				[QGVAR(all_execute),[_pickup_code,_object,_action],THIS_FILE] call FFUNC(callEvent);
			};
			TRACE_1("Object Picked Up",ARR_3(_caller, _object, _action_id));
			
			_carried_objects = [_instance_id,TMF_HK_CARRIED_ITEMS,0] call FFUNC(getMissionVar);
			_carried_objects = _carried_objects + 1;
			[_instance_id,TMF_HK_CARRIED_ITEMS,_carried_objects] call FFUNC(setMissionVar);
			
			// This will move the object along with the player.
			// If the player dies or drops the object, it will be where the player died or dropped the object.
			[_object, _caller, _action_id,_action] spawn {
				private ["_object","_player","_action_id","_action","_has_object","_obj_var_picked","_obj_var","_2d_pos","_message","_params","_player_name","_new_pos"
						,"_marker","_parameters","_item_desc"];
				DEFAULT_PARAM(_object,0,objNull);
				DEFAULT_PARAM(_player,1,objNull);
				DEFAULT_PARAM(_action_id,2,-1);
				DEFAULT_PARAM(_action,3,[]);
				_player_name = [_player] call FFUNC(playerName);
				_has_object = true;
				_obj_var_picked = format["mission_object_pickedup_%1",_action_id];
				_obj_var = format["mission_object_pickup_player_%1",_action_id];
				_parameters = [_action] call FFUNC(actionGetParams);
				_item_desc = [_parameters, "ITEM_DESC", ([_object] call FFUNC(displayName)),THIS_FILE] call FFUNC(hashGet);
				TRACE_1("Begin Follow Player",ARR_3(_player_name, _object, _action_id));
				_object hideObject true;
				while { _has_object  && alive _player} do {
					// Object is moved only if the player is not above sea (a kind of Wash Ashore equivalent in case of death)
					_2d_pos = [((getPos (vehicle _player)) select 0),((getPos (vehicle _player)) select 1)];
					if (!SurfaceIsWater _2d_pos) then {
						_new_pos = ((vehicle _player) modelToWorld [0,-1.2,0]);
						_new_pos set [2, (getPosASL (vehicle _player)) select 2];
						_object setPosASL _new_pos;
					};
					sleep 2.645678;
					_has_object = (OGETVAR(_object,_obj_var_picked,false));
				};
				_new_pos = (getPos _object) findEmptyPosition[ 1 , 20];
				if (count _new_pos > 0) then {
					if ((_new_pos vectorDistance [0,0,0]) > 1) then {
						_object setPos _new_pos;
					};
				};
				_object hideObject false;
				TRACE_1("Stop Follow Player",ARR_4(_player_name, _object, _action_id, ([_object] call FFUNC(GPSCoords))));
				if (!alive _player || isnull _player) then {
					_message = format["Player Died Carrying %1 (%2) at position %3",typeof _object, _action_id, getPos _object];
					TLOG(_message);
					_act_args = [];
					_act_args set [TMF_EXECUTE_ACTION_PARAM_ACTID, _action_id];
					_act_args set [TMF_EXECUTE_ACTION_PARAM_FUNC, "Drop"];
					_act_args set [TMF_EXECUTE_ACTION_PARAM_TARGET, _object];
					_params = [_object, _player_name, -1, _act_args];
					[QGVAR(all_action), _params,THIS_FILE] call FFUNC(callEvent);
				};
			};
		} else {
			ERROR_2("Someone already picked up",_player,_caller);
		};
	};
};		
TRACE("End");
TMFPROFILERSTOP;