#include <tmf_constants.h>
#include <tmf_macros.h>
class EDT {
	// For use in the mission editor
	class editor {
		file = QPATH(functions\editor);
		class activate { description = "$STR_TMF_FNC_ACTIVATE"; };
		class active { description = "$STR_TMF_FNC_ACTIVE"; };
		class ambush { description = "$STR_TMF_FNC_AMBUSH"; };
		class ammobox { description = "$STR_TMF_FNC_AMMOBOX"; };
		class arrest { description = "$STR_TMF_FNC_ARREST"; };
		class artillery { description = "$STR_TMF_FNC_ARTILLERY"; };
		class assassinate { description = "$STR_TMF_FNC_ASSASSINATE"; };
		class attack { description = "$STR_TMF_FNC_ATTACK"; };
		class boardVehicle { description = "$STR_TMF_FNC_BOARDVEHICLE"; };
		class boxMarker { description = "$STR_TMF_FNC_BOXMARKER"; };
		class canceled { description = "$STR_TMF_FNC_CANCELED"; };
		class cancelled { description = "$STR_TMF_FNC_CANCELED"; };
		class checkVar { description = "$STR_TMF_FNC_CHECKVAR"; };
		class civilian { description = "$STR_TMF_FNC_CIVILIAN"; };
		class completed { description = "$STR_TMF_FNC_COMPLETED"; };
		class conquer { description = "$STR_TMF_FNC_CONQUER"; };
		class create { description = "$STR_TMF_FNC_CREATE"; };
		class defend { description = "$STR_TMF_FNC_DEFEND"; };
		class delete { description = "$STR_TMF_FNC_DELETE"; };
		class destroy { description = "$STR_TMF_FNC_DESTROY"; };
		class disableExternalAI { description = "$STR_TMF_FNC_DISABLEEXTERNALAI"; };
		class ejectVehicle { description = "$STR_TMF_FNC_EJECTVEHICLE"; };
		class equip { description = "$STR_TMF_FNC_EQUIP"; };
		class getVar { description = "$STR_TMF_FNC_GETVAR"; };
		class hide { description = "$STR_TMF_FNC_HIDE"; };
		class homed { description = "$STR_TMF_FNC_HOMED"; };
		class hostage { description = "$STR_TMF_FNC_HOSTAGE"; };
		class kamikaze { description = "$STR_TMF_FNC_KAMIKAZE"; };
		class landChopper { description = "$STR_TMF_FNC_LANDCHOPPER"; };
		class lead { description = "$STR_TMF_FNC_LEAD"; };
		class marker { description = "$STR_TMF_FNC_MARKER"; };
		class noLog { description = "$STR_TMF_FNC_NOLOG"; };
		class notification { description = "$STR_TMF_FNC_NOTIFICATION"; };
		class patrol { description = "$STR_TMF_FNC_PATROL"; };
		class pickup { description = "$STR_TMF_FNC_PICKUP"; };
		class playMove { description = "$STR_TMF_FNC_PLAYMOVE"; };
		class register { description = "$STR_TMF_FNC_register"; };
		class reinfAir { description = "$STR_TMF_FNC_REINFAIR"; };
		class reinfMen { description = "$STR_TMF_FNC_REINFMEN"; };
		class reinfVec { description = "$STR_TMF_FNC_REINFVEC"; };
		class relocate { description = "$STR_TMF_FNC_RELOCATE"; };
		class removeRadio { description = "$STR_TMF_FNC_REMOVERADIO"; };
		class respawnVehicle { description = "$STR_TMF_FNC_RESPAWNVEHICLE"; };
		class server { description = "$STR_TMF_FNC_SERVER"; };
		class setAction { description = "$STR_TMF_FNC_SETACTION"; };
		class setASLHeight { };
		class setATLHeight { };
		class setVar { description = "$STR_TMF_FNC_SETVAR"; };
		class showMarkers { description = "$STR_TMF_FNC_SHOWMARKERS"; };
		class sniper { description = "$STR_TMF_FNC_SNIPER"; };
		class spawn { description = "$STR_TMF_FNC_SPAWN"; };
		class status { description = "$STR_TMF_FNC_STATUS"; };
		class stuckGroup { description = "$STR_TMF_FNC_STUCKGROUP"; };
		class stuckUnit { description = "$STR_TMF_FNC_STUCKUNIT"; };
		class takeover { description = "$STR_TMF_FNC_TAKEOVER"; };
		class task { description = "$STR_TMF_FNC_TASK"; };
		class taskSilent { description = "$STR_TMF_FNC_TASKSILENT"; };
		class weakVehicle { description = "$STR_TMF_FNC_WEAKVEHICLE"; };
		class protectVehicle { description = "$STR_TMF_FNC_PROTECTVEHICLE"; };
	};
};
class TMF {
	class root {
		file = QPATH(functions);
		class init { description = "$STR_TMF_FNC_INIT"; };
		class postInit { description = "$STR_TMF_FNC_POSTINIT"; postInit = 1; };
		class preInit { description = "$STR_TMF_FNC_PREINIT"; preInit = 1; };
	};
	class net {
		file = QPATH(functions\net);
		class addEvent { description = "$STR_TMF_FNC_ADDEVENT"; };
		class callEvent { description = "$STR_TMF_FNC_CALLEVENT"; };
		class callHC { description = "$STR_TMF_FNC_CALLHC"; };
		class log { description = "$STR_TMF_FNC_LOG"; };
		class removeEvent { description = "$STR_TMF_FNC_REMOVEEVENT"; };
		class runEvent { description = "$STR_TMF_FNC_RUNEVENT"; };
	};
	class framework {
		file = QPATH(functions\framework);
		class createMissionObject { description = "$STR_TMF_FNC_CREATEMISSIONOBJECT"; };
		class createMissionUnit { description = "$STR_TMF_FNC_CREATEMISSIONUNIT"; };
		class getFrameworkValue { description = "$STR_TMF_FNC_GETFRAMEWORKVALUE"; };
		class setFrameworkValue { description = "$STR_TMF_FNC_SETFRAMEWORKVALUE"; };
	};
	class ia {
		file = QPATH(functions\framework\ia);
		class ambush { description = "$STR_TMF_FNC_AMBUSH"; };
		class artillery { description = "$STR_TMF_FNC_ARTILLERY"; };
		class attack { description = "$STR_TMF_FNC_ATTACK"; };
		class civilian { description = "$STR_TMF_FNC_CIVILIAN"; };
		class civilianDanger { description = "$STR_TMF_FNC_CIVILIANDANGER"; };
		class civilianWaypointCode { description = "$STR_TMF_FNC_CIVILIANWAYPOINTCODE"; };
		class convergeUnits { description = "$STR_TMF_FNC_CONVERGEUNITS"; };
		class defend { description = "$STR_TMF_FNC_DEFEND"; };
		class delVecCrew { description = "$STR_TMF_FNC_DELVECCREW"; };
		class disableAIScripts { description = "$STR_TMF_FNC_DISABLEAISCRIPTS"; };
		class equip { description = "$STR_TMF_FNC_EQUIP"; };
		class getUnitSkill { description = "$STR_TMF_FNC_GETUNITSKILL"; };
		class hasTMFAI { description = "$STR_TMF_FNC_HASTMFAI"; };
		class hide { description = "$STR_TMF_FNC_HIDE"; };
		class homed { description = "$STR_TMF_FNC_HOMED"; };
		class kamikaze { description = "$STR_TMF_FNC_KAMIKAZE"; };
		class patrol { description = "$STR_TMF_FNC_PATROL"; };
		class reinfAirborne { description = "$STR_TMF_FNC_REINFAIRBORNE"; };
		class reinfInfantry { description = "$STR_TMF_FNC_REINFINFANTRY"; };
		class reinfMechanised { description = "$STR_TMF_FNC_REINFMECHANISED"; };
		class modifyItems { description = "$STR_TMF_FNC_MODIFYITEMS"; };
		class removeRadio { description = "$STR_TMF_FNC_REMOVERADIO"; };
		class sniper { description = "$STR_TMF_FNC_SNIPER"; };
		class stuckGroup { description = "$STR_TMF_FNC_STUCKGROUP"; };
		class stuckUnit { description = "$STR_TMF_FNC_STUCKUNIT"; };
		class stuckUnit2 { description = "$STR_TMF_FNC_STUCKUNIT"; };
		class unloadConvoy { description = "$STR_TMF_FNC_UNLOADCONVOY"; };
	};
	class management {
		file = QPATH(functions\framework\management);
		class cleanEvent { description = "$STR_TMF_FNC_CLEANEVENT"; };
		class cleanMissionVar { description = "$STR_TMF_FNC_CLEANMISSIONVAR"; };
		class getMissionInstance { description = "$STR_TMF_FNC_GETMISSIONINSTANCE"; };
		class getMissionJIPVar { description = "$STR_TMF_FNC_GETMISSIONJIPVAR"; };
		class getMissionVar { description = "$STR_TMF_FNC_GETMISSIONVAR"; };
		class initClient { description = "$STR_TMF_FNC_INITCLIENT"; };
		class initCommon { description = "$STR_TMF_FNC_INITCOMMON"; };
		class initializeObjects { description = "$STR_TMF_FNC_INITIALIZEOBJECTS"; };
		class initServer { description = "$STR_TMF_FNC_INITSERVER"; };
		class launchMission { description = "$STR_TMF_FNC_LAUNCHMISSION"; };
		class loadJIPVariables { description = "$STR_TMF_FNC_LOADJIPVARIABLES"; };
		class loadMissions { description = "$STR_TMF_FNC_LOADMISSIONS"; };
		class loadMarkers { description = "$STR_TMF_FNC_LOADMARKERS"; };
		class loadTasks { description = "$STR_TMF_FNC_LOADTASKS"; };
		class setMissionInstance { description = "$STR_TMF_FNC_SETMISSIONINSTANCE"; };
		class setMissionJIPVar { description = "$STR_TMF_FNC_SETMISSIONJIPVAR"; };
		class setMissionVar { description = "$STR_TMF_FNC_SETMISSIONVAR"; };
		class stopMission { description = "$STR_TMF_FNC_STOPMISSION"; };
	};
	class client {
		file = QPATH(functions\framework\client);
		class clientAIActions { description = "$STR_TMF_FNC_CLIENTAIACTIONS"; };
		class clientExecuteActivate { description = "$STR_TMF_FNC_CLIENTEXECUTEACTIVATE"; };
		class clientExecuteDisembarkAI { description = "$STR_TMF_FNC_CLIENTEXECUTEDISEMBARKAI"; };
		class clientExecuteDrop { description = "$STR_TMF_FNC_CLIENTEXECUTEDROP"; };
		class clientExecuteEjectPassenger { description = "$STR_TMF_FNC_CLIENTEXECUTEEJECTPASSENGER"; };
		class clientExecuteEmbarkAI { description = "$STR_TMF_FNC_CLIENTEXECUTEEMBARKAI"; };
		class clientExecuteHostage { description = "$STR_TMF_FNC_CLIENTEXECUTEHOSTAGE"; };
		class clientExecuteLead { description = "$STR_TMF_FNC_CLIENTEXECUTELEAD"; };
		class clientExecutePickup { description = "$STR_TMF_FNC_CLIENTEXECUTEPICKUP"; };
		class clientExecuteReleaseAI { description = "$STR_TMF_FNC_CLIENTEXECUTERELEASEAI"; };
		class clientExecuteTeleportAI { description = "$STR_TMF_FNC_CLIENTEXECUTETELEPORTAI"; };
		class clientSetupActivate { description = "$STR_TMF_FNC_CLIENTSETUPACTIVATE"; };
		class clientSetupArrest { description = "$STR_TMF_FNC_CLIENTSETUPARREST"; };
		class clientSetupAssassinate { description = "$STR_TMF_FNC_CLIENTSETUPASSASSINATE"; };
		class clientSetupConquer { description = "$STR_TMF_FNC_CLIENTSETUPCONQUER"; };
		class clientSetupDestroy { description = "$STR_TMF_FNC_CLIENTSETUPDESTROY"; };
		class clientSetupDrop { description = "$STR_TMF_FNC_CLIENTSETUPDROP"; };
		class clientSetupHostage { description = "$STR_TMF_FNC_CLIENTSETUPHOSTAGE"; };
		class clientSetupLead { description = "$STR_TMF_FNC_CLIENTSETUPLEAD"; };
		class clientSetupPickup { description = "$STR_TMF_FNC_CLIENTSETUPPICKUP"; };
		class clientSetupTakeOver { description = "$STR_TMF_FNC_CLIENTSETUPTAKEOVER"; };
	};
	class common {
		file = QPATH(functions\framework\common);
		class actionGet { description = "$STR_TMF_FNC_ACTIONGET"; };
		class actionGetEvent { description = "$STR_TMF_FNC_ACTIONGETEVENT"; };
		class actionGetID { description = "$STR_TMF_FNC_ACTIONGETID"; };
		class actionGetInstance { description = "$STR_TMF_FNC_ACTIONGETINSTANCE"; };
		class actionGetLocal { description = "$STR_TMF_FNC_ACTIONGETLOCAL"; };
		class actionGetObjParams { description = "$STR_TMF_FNC_ACTIONGETOBJPARAMS"; };
		class actionGetParams { description = "$STR_TMF_FNC_ACTIONGETPARAMS"; };
		class actionGetType { description = "$STR_TMF_FNC_ACTIONGETTYPE"; };
		class actionSet { description = "$STR_TMF_FNC_ACTIONSET"; };
		class actionSetEvent { description = "$STR_TMF_FNC_ACTIONSETEVENT"; };
		class actionSetID { description = "$STR_TMF_FNC_ACTIONSETID"; };
		class actionSetInstance { description = "$STR_TMF_FNC_ACTIONSETINSTANCE"; };
		class actionSetLocal { description = "$STR_TMF_FNC_ACTIONSETLOCAL"; };
		class actionSetObjParams { description = "$STR_TMF_FNC_ACTIONSETOBJPARAMS"; };
		class actionSetParams { description = "$STR_TMF_FNC_ACTIONSETPARAMS"; };
		class actionSetType { description = "$STR_TMF_FNC_ACTIONSETTYPE"; };
		class executeObjectAction { description = "$STR_TMF_FNC_EXECUTEOBJECTACTION"; };
		class getActions { description = "$STR_TMF_FNC_GETACTIONS"; };
		class getAllActionID { description = "$STR_TMF_FNC_GETALLACTIONID"; };
		class getInstanceID { description = "$STR_TMF_FNC_GETINSTANCEID"; };
		class getStringVar { description = "$STR_TMF_FNC_GETSTRINGVAR"; };
		class marker { description = "$STR_TMF_FNC_MARKER"; };
		class registerObject { description = "$STR_TMF_FNC_REGISTEROBJECT"; };
		class setActions { description = "$STR_TMF_FNC_SETACTIONS"; };
		class setInstanceID { description = "$STR_TMF_FNC_SETINSTANCEID"; };
		class storeObject { description = "$STR_TMF_FNC_STOREOBJECT"; };
		class storeVehicle { description = "$STR_TMF_FNC_STOREVEHICLE"; };
		class task { description = "$STR_TMF_FNC_TASK"; };
		class updateMarker { description = "$STR_TMF_FNC_UPDATEMARKER"; };
		class updateObjectMarker { description = "$STR_TMF_FNC_UPDATEOBJECTMARKER"; };
		class updateTask { description = "$STR_TMF_FNC_UPDATETASK"; };
	};
	class event {
		file = QPATH(functions\framework\event);
		class addVarEvent { description = "$STR_TMF_FNC_ADDVAREVENT"; };
		class eventObjectiveArrestFailed { description = "$STR_TMF_FNC_EVENTOBJECTIVEARRESTFAILED"; };
		class eventObjectiveArrestSuccess { description = "$STR_TMF_FNC_EVENTOBJECTIVEARRESTSUCCESS"; };
		class eventObjectiveAssassinate { description = "$STR_TMF_FNC_EVENTOBJECTIVEASSASSINATE"; };
		class eventObjectiveDestroy { description = "$STR_TMF_FNC_EVENTOBJECTIVEDESTROY"; };
		class eventObjectiveHostageFailed { description = "$STR_TMF_FNC_EVENTOBJECTIVEHOSTAGEFAILED"; };
		class eventObjectiveLeadFailed { description = "$STR_TMF_FNC_EVENTOBJECTIVELEADFAILED"; };
		class eventObjectiveLeadSuccess { description = "$STR_TMF_FNC_EVENTOBJECTIVELEADSUCCESS"; };
		class eventObjectiveTakeOverKilled { description = "$STR_TMF_FNC_EVENTOBJECTIVETAKEOVERKILLED"; };
		class runVarEvent { description = "$STR_TMF_FNC_RUNVAREVENT"; };
	};
	class server {
		file = QPATH(functions\framework\server);
		class playerDisconnected { description = "$STR_TMF_FNC_PLAYERDISCONNECTED"; };
		class serverExecuteActivate { description = "$STR_TMF_FNC_SERVEREXECUTEACTIVATE"; };
		class serverExecuteDrop { description = "$STR_TMF_FNC_SERVEREXECUTEDROP"; };
		class serverExecuteEjectPassenger { description = "$STR_TMF_FNC_SERVEREXECUTEEJECTPASSENGER"; };
		class serverExecuteHostage { description = "$STR_TMF_FNC_SERVEREXECUTEHOSTAGE"; };
		class serverExecuteLead { description = "$STR_TMF_FNC_SERVEREXECUTELEAD"; };
		class serverExecutePickup { description = "$STR_TMF_FNC_SERVEREXECUTEPICKUP"; };
		class serverExecuteReleaseAI { description = "$STR_TMF_FNC_SERVEREXECUTERELEASEAI"; };
		class serverSetupActivate { description = "$STR_TMF_FNC_SERVERSETUPACTIVATE"; };
		class serverSetupArrest { description = "$STR_TMF_FNC_SERVERSETUPARREST"; };
		class serverSetupAssassinate { description = "$STR_TMF_FNC_SERVERSETUPASSASSINATE"; };
		class serverSetupConquer { description = "$STR_TMF_FNC_SERVERSETUPCONQUER"; };
		class serverSetupConquerCheck { description = "$STR_TMF_FNC_SERVERSETUPCONQUERCHECK"; };
		class serverSetupConquerExec { description = "$STR_TMF_FNC_SERVERSETUPCONQUEREXEC"; };
		class serverSetupDestroy { description = "$STR_TMF_FNC_SERVERSETUPDESTROY"; };
		class serverSetupHostage { description = "$STR_TMF_FNC_SERVERSETUPHOSTAGE"; };
		class serverSetupLead { description = "$STR_TMF_FNC_SERVERSETUPLEAD"; };
		class serverSetupPickup { description = "$STR_TMF_FNC_SERVERSETUPPICKUP"; };
		class serverSetupTakeOver { description = "$STR_TMF_FNC_SERVERSETUPTAKEOVER"; };
		class serverSetupTakeOverCheck { description = "$STR_TMF_FNC_SERVERSETUPTAKEOVERCHECK"; };
		class serverSetupTakeOverExec { description = "$STR_TMF_FNC_SERVERSETUPTAKEOVEREXEC"; };
	};
	class strings {
		file = QPATH(functions\strings);
		class removeLineBreaks { description = "$STR_TMF_FNC_REMOVELINEBREAKS"; };
	};
	class arrays {
		file = QPATH(functions\arrays);
		class arrayDump { description = "$STR_TMF_FNC_ARRAYDUMP"; };
		class arrayFilter { description = "$STR_TMF_FNC_ARRAYFILTER"; };
		class arrayPushStack { description = "$STR_TMF_FNC_ARRAYPUSHSTACK"; };
		class arrayRandomIndex { description = "$STR_TMF_FNC_ARRAYRANDOMINDEX"; };
		class arrayRandomize { description = "$STR_TMF_FNC_ARRAYRANDOMIZE"; };
		class arrayRandomVal { description = "$STR_TMF_FNC_ARRAYRANDOMVAL"; };
		class hashDump { description = "$STR_TMF_FNC_HASHDUMP"; };
		class hashEmpty { description = "$STR_TMF_FNC_HASHEMPTY"; };
		class hashGet { description = "$STR_TMF_FNC_HASHGET"; };
		class hashKeys { description = "$STR_TMF_FNC_HASHKEYS"; };
		class hashSet { description = "$STR_TMF_FNC_HASHSET"; };
		class pairGet { description = "$STR_TMF_FNC_PAIRGET"; };
		class pairSet { description = "$STR_TMF_FNC_PAIRSET"; };
	};
	class communication {
		file = QPATH(functions\comm);
		class globalChat { description = "$STR_TMF_FNC_GLOBALCHAT"; };
		class groupChat { description = "$STR_TMF_FNC_GROUPCHAT"; };
		class handleMessage { description = "$STR_TMF_FNC_HANDLEMESSAGE"; };
		class hasRadio { description = "$STR_TMF_FNC_HASRADIO"; };
		class HQChat { description = "$STR_TMF_FNC_HQCHAT"; };
		class notification { description = "$STR_TMF_FNC_NOTIFICATION"; };
		class sideChat { description = "$STR_TMF_FNC_SIDECHAT"; };
		class systemChat { description = "$STR_TMF_FNC_SYSTEMCHAT"; };
		class taskHint { description = "$STR_TMF_FNC_TASKHINT"; };
		class titleText { description = "$STR_TMF_FNC_TITLETEXT"; };
		class vehicleChat { description = "$STR_TMF_FNC_VEHICLECHAT"; };
	};
	class math {
		file = QPATH(functions\math);
		class dirTo { description = "$STR_TMF_FNC_DIRTO"; };
		class distTo { description = "$STR_TMF_FNC_DISTTO"; };
		class getPos2D { description = "$STR_TMF_FNC_GETPOS2D"; };
		class getPos3D { description = "$STR_TMF_FNC_GETPOS3D"; };
		class getRanAirPointCircle { description = "$STR_TMF_FNC_GETRANAIRPOINTCIRCLE"; };
		class getRanDirPoint { description = "$STR_TMF_FNC_GETRANDIRPOINT"; };
		class getRanOuterAirPoint { description = "$STR_TMF_FNC_GETRANOUTERAIRPOINT"; };
		class getRanPointCircle { description = "$STR_TMF_FNC_GETRANPOINTCIRCLE"; };
		class getRanPointCircleBig { description = "$STR_TMF_FNC_GETRANPOINTCIRCLEBIG"; };
		class getRanRange { description = "$STR_TMF_FNC_GETRANRANGE"; };
		class getRanRangeInt { description = "$STR_TMF_FNC_GETRANRANGEINT"; };
		class getShape { description = "$STR_TMF_FNC_GETSHAPE"; };
		class getSlope { description = "$STR_TMF_FNC_GETSLOPE"; };
		class inShape { };
		class relPos2D { description = "$STR_TMF_FNC_RELPOS2D"; };
		class relPos3D { description = "$STR_TMF_FNC_RELPOS3D"; };
		class shapeIsRect { description = "$STR_TMF_FNC_SHAPEISRECT"; };
		class toShape { description = "$STR_TMF_FNC_TOSHAPE"; };
	};
	class player {
		file = QPATH(functions\player);
		class addScore { description = "$STR_TMF_FNC_ADDSCORE"; };
		class allPlayers { description = "$STR_TMF_FNC_ALLPLAYERS"; };
		class playerCount { description = "$STR_TMF_FNC_PLAYERCOUNT"; };
		class playerDist { description = "$STR_TMF_FNC_PLAYERDIST"; };
		class playerHasRole { description = "$STR_TMF_FNC_PLAYERHASROLE"; };
		class safeEject { description = "$STR_TMF_FNC_SAFEEJECT"; };
		class vehicleEnter { description = "$STR_TMF_FNC_VEHICLEENTER"; };
		class vehicleExit { description = "$STR_TMF_FNC_VEHICLEEXIT"; };
	};
	class tools {
		file = QPATH(functions\tools);
		class acvEnabled { description = "$STR_TMF_FNC_ACVENABLED"; };
		class addObjectMarker { description = "$STR_TMF_FNC_ADDOBJECTMARKER"; };
		class buildingPosArray { description = "$STR_TMF_FNC_BUILDINGPOSARRAY"; };
		class buildingPosCalculator { description = "$STR_TMF_FNC_BUILDINGPOSCALCULATOR"; };
		class buildingPositions { description = "$STR_TMF_FNC_BUILDINGPOSITIONS"; };
		class buildingSniperPosBuilder { description = "$STR_TMF_FNC_BUILDINGSNIPERPOSBUILDER"; };
		class compassDir { description = "$STR_TMF_FNC_COMPASSDIR"; };
		class createGroup { description = "$STR_TMF_FNC_CREATEGROUP"; };
		class createMarker { description = "$STR_TMF_FNC_CREATEMARKER"; };
		class createMarkerLocal { description = "$STR_TMF_FNC_CREATEMARKERLOCAL"; };
		class createTrigger { description = "$STR_TMF_FNC_CREATETRIGGER"; };
		class createUnit { description = "$STR_TMF_FNC_CREATEUNIT"; };
		class createVehicle { description = "$STR_TMF_FNC_CREATEVEHICLE"; };
		class deleteWaypoints { description = "$STR_TMF_FNC_DELETEWAYPOINTS"; };
		class deleteGroup { description = "$STR_TMF_FNC_DELETEGROUP"; };
		class deleteVehicle { description = "$STR_TMF_FNC_DELETEVEHICLE"; };
		class displayName { description = "$STR_TMF_FNC_DISPLAYNAME"; };
		class equalSide { description = "$STR_TMF_FNC_EQUALSIDE"; };
		class getConfigEntry { description = "$STR_TMF_FNC_GETCONFIGENTRY"; };
		class getCrewType { description = "$STR_TMF_FNC_GETCREWTYPE"; };
		class getLandingPos { description = "$STR_TMF_FNC_GETLANDINGPOS"; };
		class getRoadPath { description = "$STR_TMF_FNC_GETROADPATH"; };
		class getSide { description = "$STR_TMF_FNC_GETSIDE"; };
		class getVehicleTurrets { description = "$STR_TMF_FNC_GETVEHICLETURRETS"; };
		class GPSCoords { description = "$STR_TMF_FNC_GPSCOORDS"; };
		class isHC { description = "$STR_TMF_FNC_ISHC"; };
		class isSHC { description = "$STR_TMF_FNC_ISSHC"; };
		class markerToTrigger { description = "$STR_TMF_FNC_MARKERTOTRIGGER"; };
		class nextJipID { description = "$STR_TMF_FNC_NEXTJIPID"; };
		class playerName { description = "$STR_TMF_FNC_PLAYERNAME"; };
		class playMove { description = "$STR_TMF_FNC_PLAYMOVE"; };
		class respawnVehicle { description = "$STR_TMF_FNC_RESPAWNVEHICLE"; };
		class setHeight { description = "$STR_TMF_FNC_SETHEIGHT"; };
		class spawnCrew { description = "$STR_TMF_FNC_SPAWNCREW"; };
		class spawnGroup { description = "$STR_TMF_FNC_SPAWNGROUP"; };
		class spawnVehicle { description = "$STR_TMF_FNC_SPAWNVEHICLE"; };
		class translate { description = "$STR_TMF_FNC_TRANSLATE"; };
		class triggerToMarker { description = "$STR_TMF_FNC_TRIGGERTOMARKER"; };
	};
	class special {
		file = QPATH(functions\special);
		class execC { description = "$STR_TMF_FNC_EXECC"; };
		class execHC { description = "$STR_TMF_FNC_EXECHC"; };
		class execS { description = "$STR_TMF_FNC_EXECS"; };
	};
	class integration {
		file = QPATH(functions\integration);
		class exportMissionObject { description = "$STR_TMF_FNC_PLAYERCOUNT"; };
	};
};