//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "tools\fn_createUnit.sqf"
#include <tmf_constants.h>
#include <tmf_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;

private ["_unit","_units","_grp","_pos","_type","_init","_rank","_instance_id"];
DEFAULT_PARAM(_instance_id,0,TMF_SERVER_INSTANCE_ID);
DEFAULT_PARAM(_type,1,"");
DEFAULT_PARAM(_grp,2,grpNull);
DEFAULT_PARAM(_pos,3,ARR_3(0,0,0));
DEFAULT_PARAM(_dist,4,0);
DEFAULT_PARAM(_init,5,"");
DEFAULT_PARAM(_rank,6,"private");
DEFAULT_PARAM(_skill,7,([] call FFUNC(getUnitSkill)));

if (_instance_id == "") then { _instance_id = TMF_SERVER_INSTANCE_ID; };

if (!IS_STRING(_init)) then {
	_init = "";
};

_new_pos = [];
if (_dist > 0) then {
	_new_pos = _pos findEmptyPosition[ 1 , _dist , _type];
	if (count _new_pos > 0) then { _pos = _new_pos; };
};
if (OR_ELSE(!(IS_STRING(_rank)),(_rank == ""))) then {
	_rank = "private";
};
_unit = objNull;
_units = units _grp;
if (isnil "_units") then { _units = []; };			
TRACE_2("CreateUnit",ARR_2(_type,_units),ARR_5(_pos, _grp, _init, _skill, _rank));
_type createUnit [ _pos, _grp, _init, _skill, _rank];
{ if (!(_x in _units)) exitWith{_unit = _x;};
} foreach (units _grp);
_unit disableConversation true;
_unit setVariable ["BIS_noCoreConversations", true];
[_unit,_instance_id] call FFUNC(setInstanceID);
[_unit] call FFUNC(modifyItems);
[QGVAR(s_store_vehicle),[_unit,_instance_id],THIS_FILE] call FFUNC(callEvent);

TRACE_1("End",ARR_3(_unit,typeof _unit,getPos _unit));
TMFPROFILERSTOP;
_unit
