// convoyAmbush.sqf
//  APRIL 2013 - norrin
//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "nornn_convoy\fn_ambush.sqf"
#include <core_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;

private ["_markerArray","_convoyArray","_groups","_convoyUnits","_restartConvoy","_noEnemy","_leader","_enemy","_d","_groupsNotNull","_aliveConvoy","_posEnemy",
		 "_units","_grpNoTarget","_grpNoTarget2","_loop","_group","_x","_timeout","_known"];
if (!isServer) exitWith {};
_markerArray  	= _this select 0;
_convoyArray  	= _this select 1;
_groups		  	= _this select 2;
_restartConvoy	= _this select 3;
_noEnemy 	  	= false;
_leader 		= objNull;
_enemy 			= objNull; 
_d				= 0;
_groupsNotNull	= [];
_aliveConvoy	= [];
_posEnemy   	= [];
_units			= [];
_convoyUnits 	= [];
_timeout		= (GVAR(AMBUSH_TIMEOUT) * 2) max 60;
_known = objNull;
for "_loop" from 0 to ((count _groups) - 1) step 1 do {
	_group = _groups select _loop;
	if !(isNull _group) then {
		{doStop _x; _convoyUnits = _convoyUnits + [_x]}forEach units _group;
	} else {
		_groups set [_loop,"XxDeLxX"];
	};
};
_groups = _groups - ["XxDeLxX"];
TRACE_1("Groups",ARR_2(_groups,count _convoyUnits));

{_x setVariable [QGVAR(enemyDetected), [objNull, []], false]}forEach _convoyUnits;
_grpNoTarget 	= _groups;
_grpNoTarget2 	= _groups;
if (!isNil QUOTE(FUNC(ambushStarted))) then {
	[_groups] call FUNC(ambushStarted);
};
// While enemy units are detected
waituntil {
	for "_loop" from 0 to ((count _grpNoTarget) - 1) step 1 do {
		_group = _grpNoTarget select _loop;
		// if group detects enemy then SAD 
		if  !(isNull _group) then {
			_leader = leader _group;
			_units  = units _group; 
			if (!isNull (_leader findNearestEnemy (getPos _leader))) then {
				_enemy = _leader findNearestEnemy (getPos _leader);
				if (_enemy != ((_leader getVariable [QGVAR(enemyDetected),[objNull, []]]) select 0)) then {
					_posEnemy = getPos _enemy;
					{
						_known = ((_x getVariable [QGVAR(enemyDetected),[objNull, []]]) select 0);
						if (isNull _known || {(_known distance _x) > (_enemy distance _x)}) then {
							_x doMove _posEnemy;
							_x setVariable [QGVAR(enemyDetected), [_enemy,_posEnemy], false];
						};
						if ((_x knowsAbout _enemy) < 1.5) then {
							_x reveal [_enemy, 1.5];
						};
					} forEach _units;
					_grpNoTarget2 = _grpNoTarget2 - [_group];
				};
				if ((_enemy distance _leader) < 500) then {
					_d = 0;
				};
			};
			if (isNull ((_leader getVariable [QGVAR(enemyDetected),[objNull, []]]) select 0) && _d > 20) then {
				_grpNoTarget2 = _grpNoTarget2 - [_group];
			};
		} else {
			_grpNoTarget2 = _grpNoTarget2 - [_group];
		};
		sleep 0.01;
	};
	_grpNoTarget = _grpNoTarget2;
	_groupsNotNull = _groups;
	// if all groups do not detect any enemies then exit loop
	if (_d > _timeout) then {
		if (isNull _enemy) exitWith {_noEnemy = true};
		for "_loop" from 0 to ((count _groups) - 1) step 1 do {
			_group = _groups select _loop;
			if (_group != grpNull) then {	
				_leader = leader _group;
				if (isNull(_leader findNearestEnemy (getPos _leader))) then {_groupsNotNull = _groupsNotNull - [_group]};
			} else {
				_groupsNotNull = _groupsNotNull - [_group];
			};
			sleep 0.01;
		};
	};
	if (count _groupsNotNull == 0) then {_noEnemy = true};
	_d = _d + 1;
	sleep 0.5;
	_noEnemy;
};
if (!isNil QUOTE(FUNC(ambushEnded))) then {
	[_groups] call FUNC(ambushEnded);
};
if (_restartConvoy) then {
	{
		if (alive _x && canMove _x) then {
			_aliveConvoy = _aliveConvoy + [_x];
		};
	} forEach _convoyArray;
	_groupsNotNull = [];
	{
		if (_x != grpNull) then {
			_groupsNotNull = _groupsNotNull + [_x];
		};
	} forEach _groups;
	[_markerArray,_aliveConvoy,_groupsNotNull,_restartConvoy] spawn FUNC(Restart);
} else {
	DEBUG_1("Do not restart convoy",_groups);
};
TRACE("End");
TMFPROFILERSTOP;