// convoyDefend_init.sqf
//  APRIL 2013 - norrin
//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "nornn_convoy\fn_init.sqf"
#include <core_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;
if (!isServer) exitWith {};

private ["_marker_prefix","_vehicle_prefix","_markerArray","_convoyArray","_restartConvoy","_name","_count","_trigger","_auto_config","_array"]; 

_auto_config = false;
_marker_prefix = "convoy";
_vehicle_prefix = "convoy";
_markerArray = [];
_convoyArray = [];
_restartConvoy = true;
_trigger = objNull;
_speed_limit = -1;

if ((count _this) > 0) then {
	if (IS_OBJECT((_this select 0))) then {
		_auto_config = true;
	};
	
	if (_auto_config) then {
		_name = vehicleVarName (_this select 0);
		_array = toArray(_name);
		_name = [];
		{
			if (_x in toArray("_")) exitWith {};
			_name set [count _name, _x];
		} foreach _array;
		_vehicle_prefix = _name;
		_name = toString(_name);
		if (count _this > 1) then {
			if (IS_STRING((_this select 1))) then {
				DEFAULT_PARAM(_marker_prefix,1,true);
				DEFAULT_PARAM(_restartConvoy,2,true);
				DEFAULT_PARAM(_trigger,3,objNull);
				DEFAULT_PARAM(_speed_limit,4,-1);
			} else {
				_marker_prefix = _name;
				DEFAULT_PARAM(_restartConvoy,1,true);
				DEFAULT_PARAM(_trigger,2,objNull);
				DEFAULT_PARAM(_speed_limit,3,-1);
			};
		} else {
			_marker_prefix = _name;
			DEFAULT_PARAM(_restartConvoy,1,true);
			DEFAULT_PARAM(_trigger,2,objNull);
			DEFAULT_PARAM(_speed_limit,3,-1);
		};
	} else {
		DEFAULT_PARAM(_vehicle_prefix,0,"convoy");
		DEFAULT_PARAM(_marker_prefix,1,"convoy");
		DEFAULT_PARAM(_restartConvoy,2,true);
		DEFAULT_PARAM(_trigger,3,objNull);
		DEFAULT_PARAM(_speed_limit,4,-1);
	};
};

if (IS_STRING(_marker_prefix)) then {
	_missing = 0;
	_count = 0;
	while {_missing < 2} do {
		_name = format["%1_%2",_marker_prefix,_count];
		if (IS_MARKER(_name)) then {
			_missing = 0;
			_markerArray set [count _markerArray, _name];
		} else {
			INC(_missing);
		};
		INC(_count);
	};
} else {
	if (IS_ARRAY(_marker_prefix)) then {
		_markerArray = _marker_prefix;
	};
};

if (IS_STRING(_vehicle_prefix)) then {
	_missing = 0;
	_count = 0;
	while {_missing < 2} do {
		_name = format["%1_%2",_vehicle_prefix,_count];
		if !(isNull(missionNamespace getVariable [_name,objNull])) then {
			_missing = 0;
			_convoyArray set [count _convoyArray, missionNamespace getVariable [_name,objNull]];
		} else {
			INC(_missing);
		};
		INC(_count);
	};
} else {
	if (IS_ARRAY(_vehicle_prefix)) then {
		_convoyArray = _vehicle_prefix;
	};
};

if (count _markerArray <= 0 || count _convoyArray <= 0) exitWith { ERROR_1("Invalid Input",_this); };

if (_speed_limit > 0) then {
	{
		_x setVariable [QGVAR(SpeedLimit),_speed_limit];
	} foreach _convoyArray;
};

if (isNull(_trigger)) then {
	// Start the convoy moving
	[_markerArray,_convoyArray,_restartConvoy] spawn FUNC(Move);
} else {
	_statements = triggerStatements _trigger;
	TRACE_1("Trigger Statements",_statements);
	_statements set [1, ((_statements select 1) + format ["; nul = [%1,%2,%3] spawn %4;",_markerArray, _convoyArray, _restartConvoy, QUOTE(FUNC(move))])];
	TRACE_1("Updated Statements",_statements);
	_trigger setTriggerStatements _statements;
};

TRACE("End");
TMFPROFILERSTOP;


