// convoyMaxSpeed.sqf 
//  APRIL 2013 - norrin
//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "nornn_convoy\fn_maxSpeed.sqf"
#include <core_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;

private ["_vcl","_markerArray","_convoyArray","_c","_count","_vcl2","_vcl3","_dir"]; 
_vcl 			= _this select 0;
_markerArray 	= _this select 1;
_convoyArray	= _this select 2;
_c 				= _this select 3;
_count 			= count _convoyArray;
_vcl2 			= objNull;
_vcl3 			= objNull; 
if (!local _vcl) exitWith {};
//added to halt convoy at destination
_destinationEnd = _markerArray select ((count _markerArray) -1);
if (_c < (_count - 2)) then {_vcl2 = _convoyArray select (_c + 1)};
if (_c > 0 && _count > 1) then {_vcl3 = _convoyArray select (_c - 1)};
TRACE_1("MaxSpeed",ARR_4(_c,_vcl, _vcl2, _vcl3));	
waituntil { 	
	if ((_vcl distance (getMarkerPos _destinationEnd)) < 10) then {_vcl setVariable [QGVAR(Destination),true, false]};
	if ((_vcl getVariable [QGVAR(SpeedLimit),-1]) > 0 && {(_vcl getVariable [QGVAR(SpeedLimit),-1]) < speed _vcl}) then {
		TRACE_1("Speed Limit",ARR_3(_vcl,speed _vcl,(_vcl getVariable ARR_2(QGVAR(SpeedLimit),-1))));
		_vcl limitSpeed (_vcl getVariable [QGVAR(SpeedLimit),-1]);
	};
	if (!(_vcl getVariable [QGVAR(Destination),false])) then {
		_aliveConvoy	= [];
		{if (IS_OBJECT(_x) && {canMove _x} && {isNull (_x findNearestEnemy (getPos _x))}) then {_aliveConvoy = _aliveConvoy + [_x]}} forEach _convoyArray;
		if (!isNil "_vcl2" && {IS_OBJECT(_vcl2)} && {!isNull _vcl2}) then {
			if (_vcl2 getVariable [QGVAR(Destination),false]) then {
				if (IS_OBJECT((_convoyArray select (_c + 1))) && {_vcl2 == (_convoyArray select (_c + 1)) || isNull (_convoyArray select (_c + 1))}) then {
					_convoyArray set [(_c + 1), "XxDeLxX"];
					_convoyArray = _convoyArray - ["XxDeLxX"];
				};
				_vcl2 = objNull;
				if ((count _convoyArray - 1) > _c) then {
					_vcl2 = _convoyArray select (_c + 1);
				};
			};
			if (!isNil "_vcl2" && {IS_OBJECT(_vcl2)} && {!isNull _vcl2}) then {
				if (speed _vcl > 50) then {	
					_vcl setVelocity [(11 * (sin getDir _vcl)), (11 * (cos getDir _vcl)), velocity _vcl select 2];
				};
				if ((_vcl distance _vcl2) > 70) then {
					TRACE_1("Start correcting vehicle behind too far",ARR_3(_vcl,_vcl2,(_vcl distance _vcl2)));
					waituntil {
						if ((_vcl getVariable [QGVAR(SpeedLimit),-1]) > 0 && {(_vcl getVariable [QGVAR(SpeedLimit),-1]) < speed _vcl}) then {
							TRACE_1("Speed Limit",ARR_3(_vcl,speed _vcl,(_vcl getVariable ARR_2(QGVAR(SpeedLimit),-1))));
							_vcl limitSpeed (_vcl getVariable [QGVAR(SpeedLimit),-1]);
						};
						_dir = getDir _vcl;
						if (_vcl distance _vcl2 <= 100) then {
							if (((sin _dir) * (velocity _vcl select 0)) > 3) then {_vcl setVelocity [(velocity _vcl select 0) - (1 * (sin _dir)), (velocity _vcl select 1), velocity _vcl select 2]};
							if (((cos _dir) * (velocity _vcl select 1)) > 3) then {_vcl setVelocity [(velocity _vcl select 0), (velocity _vcl select 1) - (1 * (cos _dir)), velocity _vcl select 2]};
						} else {
							if (((sin _dir) * (velocity _vcl select 0)) > 1) then {_vcl setVelocity [(velocity _vcl select 0) - (2 * (sin _dir)), (velocity _vcl select 1), velocity _vcl select 2]};
							if (((cos _dir) * (velocity _vcl select 1)) > 1) then {_vcl setVelocity [(velocity _vcl select 0), (velocity _vcl select 1) - (2 * (cos _dir)), velocity _vcl select 2]};
						};
						sleep 0.1;
						(!(alive _vcl) || isNull _vcl2 || {!(alive _vcl2)} || {(_vcl distance _vcl2 <= 60)} || {(_vcl getVariable [QGVAR(Destination),false])} || {(!isNil "_vcl3" && {IS_OBJECT(_vcl3)} && {!isNull _vcl3} && {_vcl distance _vcl3 < 15})})
					};
					TRACE_1("Vehicle behind at less than 60m",ARR_3(_vcl,_vcl2,(_vcl distance _vcl2)));
				};
			};
		};
		if (!isNil "_vcl3" && {IS_OBJECT(_vcl3)} && {!isNull _vcl3}) then {
			if (_vcl3 getVariable [QGVAR(Destination),false]) then {
				if (IS_OBJECT((_convoyArray select (_c - 1))) && {_vcl3 == (_convoyArray select (_c - 1)) || isNull (_convoyArray select (_c - 1))}) then {
					_convoyArray set [(_c - 1), "XxDeLxX"];
					_convoyArray = _convoyArray - ["XxDeLxX"];
				};
				_vcl3 = objNull;
				if ((count _convoyArray - 1) > 1 && _c > 0) then {
					_vcl3 = _convoyArray select (_c - 1);
				};
			};
			if (speed _vcl > 50) then {	
				_vcl setVelocity [(11 * (sin getDir _vcl)), (11 * (cos getDir _vcl)), velocity _vcl select 2];
			};
			if (!isNull _vcl3 && {_vcl distance _vcl3 < 30}) then	{
				TRACE_1("Start correcting vehicle before too close",ARR_3(_vcl,_vcl3,(_vcl distance _vcl3)));
				waituntil {	
					if ((_vcl getVariable [QGVAR(SpeedLimit),-1]) > 0 && {(_vcl getVariable [QGVAR(SpeedLimit),-1]) < speed _vcl}) then {
						TRACE_1("Speed Limit",ARR_3(_vcl,speed _vcl,(_vcl getVariable ARR_2(QGVAR(SpeedLimit),-1))));
						_vcl limitSpeed (_vcl getVariable [QGVAR(SpeedLimit),-1]);
					};
					_dir = getDir _vcl;
					if (((sin _dir) * (velocity _vcl select 0)) > 1) then {_vcl setVelocity [(velocity _vcl select 0) - (2 * (sin _dir)), (velocity _vcl select 1), velocity _vcl select 2]};
					if (((cos _dir) * (velocity _vcl select 1)) > 1) then {_vcl setVelocity [(velocity _vcl select 0), (velocity _vcl select 1) - (2 * (cos _dir)), velocity _vcl select 2]};
					if ((_vcl3 distance _vcl) < 10) then { _vcl limitSpeed 5; };
					sleep 0.1;
					(!(alive _vcl) || isNull _vcl3 || {!(alive _vcl3)} || {((_vcl distance _vcl3) >= 37)} || {(_vcl getVariable [QGVAR(Destination),false])} || {(!isNil "_vcl2" && {IS_OBJECT(_vcl2)} && {!isNull _vcl2} && {_vcl distance _vcl2 > 90})})
				};
				TRACE_1("Vehicle in front at more than 30m",ARR_3(_vcl,_vcl3,(_vcl distance _vcl3)));
			};
		};
	};
	sleep 0.1;
	(!alive _vcl || {(_vcl getVariable [QGVAR(Destination),false])})
};
_vcl doMove getPos _vcl; 
//_vcl stop true;
sleep 4;
_dir = getDir _vcl;
_vcl setVariable [QGVAR(restartPos), [(getPos _vcl), (getDir _vcl)], false];
sleep 1;
//_vcl stop false;

TRACE("End");
TMFPROFILERSTOP;
