// convoyMove.sqf
//  APRIL 2013 - norrin
//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "nornn_convoy\fn_move.sqf"
#include <core_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;

private ["_vcl","_markerArray","_convoyArray","_restartConvoy","_marker","_leadVcl","_groups","_markersRemaining","_aliveConvoy","_b","_c","_x","_convoyVclDestroyed","_loop","_loop1","_unit","_crew"
		,"_dismounted","_last_pos","_same"];
_markerArray 		 	= _this select 0;
_convoyArray 		 	= _this select 1;
_restartConvoy			= _this select 2;
_convoyVclDestroyed  	= false;
_marker 			 	= _markerArray select 0;
_leadVcl 			 	= _convoyArray select 0;
_markersRemaining 	 	= _markerArray;
_groups 			 	= [];
_aliveConvoy 		 	= [];
_dismounted				= [];
_b 					 	= 0;
_c 					 	= 0;

{
	_x setVariable [QGVAR(Destination),false,false];
	_x setSpeedMode "LIMITED";
	_x setBehaviour "CARELESS";
	_x doMove (getMarkerPos _marker);
	[_x, _markerArray, _convoyArray, _c] spawn FUNC(MaxSpeed); 
	_c = _c + 1;
	_x setVariable [QGVAR(Markers),_markerArray, false];
	_x setVariable [QGVAR(LastPos),(getPos _x), false];
	_x setVariable [QGVAR(LastPosSame),0, false];
	group(driver _x) setSpeedMode "LIMITED";
	group(driver _x) allowFleeing 0;
} forEach _convoyArray;
if (!isNil QUOTE(FUNC(moveStarted))) then {
	[_convoyArray] call FUNC(moveStarted);
};
_convoyVclDestroyed = false;
_c = 0;
waituntil{
	if ((_leadVcl distance (getMarkerPos _marker)) < 50) then {
		sleep 1;
		{_x doMove (getPos _x)} forEach _convoyArray;
		if (_b < (count _markerArray - 1)) then {		
			_markersRemaining = _markersRemaining - [_marker];
			_b = _b + 1;
			_marker = _markerArray select _b;
			{_x doMove getMarkerPos _marker} forEach _convoyArray;
			_c = 0;
		};
	} else {
		if (_c == 0) then {
			{_x doMove getMarkerPos _marker} forEach _convoyArray;
		};
	};
	if (count _convoyArray <= 0) then {_convoyVclDestroyed = true;};
	if (_c == 10) then {_c = 0} else {_c = _c + 1};
	{
		if (!alive _x || !canMove _x || !isNull (_x findNearestEnemy (getPos _x)) || isNull driver _x || (_x getVariable [QGVAR(Destination),false])) then {
			TRACE_1("Test Move",ARR_6(_x, !alive _x, !canMove _x, !isNull (_x findNearestEnemy (getPos _x)), isNull driver _x, (_x getVariable ARR_2(QGVAR(Destination),false))));
			_convoyVclDestroyed = true
		};
		if (_c <= 0) then {
			// Add code to detect we're stuck and remove the vehicle.
			_last_pos = _x getVariable [QGVAR(LastPos),(getPos _x)];
			if ((_last_pos distance _x) < 3) then {
				_same = _x getVariable [QGVAR(LastPosSame),0];
				INC(_same);
				 _x setVariable [QGVAR(LastPosSame),_same, false];
				 if (_same > 3) then {
					TRACE_1("Remove stuck vehicle from Convoy",ARR_2(_x,_same));
					_convoyArray set [_forEachIndex, "XxDeLxX"];
					_x setVariable [QGVAR(Destination),true,false];
				 } else {
					if (_same > 1) then {
						TRACE_1("Try unblock vehicle",ARR_2(_x,_same));
						_roads = _x nearRoads 10;
						if (count _roads > 0) then {
							[(driver _x),(position(_roads select floor(random(count _roads)))),getMarkerPos _marker] spawn { 
								(_this select 0) doMove (_this select 1);
								sleep 8;
								(_this select 0) doMove (_this select 2);
							};
						};
					};
				 };
			} else {
				_x setVariable [QGVAR(LastPos),(getPos _x),false];
			};
		};
	} forEach _convoyArray;
	_convoyArray = _convoyArray - ["XxDeLxX"];
	sleep 0.5;
	_convoyVclDestroyed
};
{if (canMove _x) then {_x setVariable [QGVAR(Destination),true,false];_x doMove (getPos _x)}} forEach _convoyArray;
{if (alive _x && canMove _x) then {_aliveConvoy = _aliveConvoy + [_x]}} forEach _convoyArray;
sleep 2;
//If vehicle is not armoured then crew disembarks
for "_loop" from 0 to ((count _convoyArray) - 1) step 1 do {	
	_vcl = _convoyArray select _loop;
	_groups = _groups + [(group _vcl)];
	_crew = crew _vcl;
	_vcl setVariable [QGVAR(VclCrew), _crew, false];
	if (alive _vcl && !(_vcl isKindOf "Tank") && !(_vcl isKindOf "Helicopter")) then {
		while {speed _vcl > 2} do {sleep 0.5};
		_dismounted = [];
		for "_loop1" from 0 to ((count _crew) - 1) step 1 do {
			_unit = _crew select _loop1;
			_unit setVariable [QGVAR(VclPos), _vcl, false];
			_unit setVariable [QGVAR(VclRole), (assignedVehicleRole _unit), false];
			if (!(_unit getVariable [QGVAR(Ignore), false])) then {
				if !((group _unit) in _groups) then {_groups = _groups + [(group _unit)]};
				if (_unit != gunner _vcl) then {
					unassignVehicle _unit;
					_unit leaveVehicle _vcl;
					_unit action ["GetOut", _vcl];
					[_unit] allowGetIn false;
					_dismounted set [count _dismounted, _unit];
				} else {
					_unit assignAsGunner _vcl;
				};
			};
			sleep 0.1;
		};
	} else {
		doStop (driver _vcl);
	};
	TRACE_1("Vehicle",ARR_4(_vcl,typeof _vcl,_crew,_dismounted));
	sleep 0.1;
};
if (!isNil QUOTE(FUNC(moveEnded))) then {
	[_convoyArray] call FUNC(moveEnded);
};
sleep 1;
{_x setBehaviour "Combat"} forEach _groups;
// Added for restarting the convoy once attack is over
[_markersRemaining,_aliveConvoy,_groups,_restartConvoy] spawn FUNC(Ambush);

TRACE("End");
TMFPROFILERSTOP;
