// convoyRestart.sqf
//  APRIL 2013 - norrin
//#define __FORCE_TRACE__
//#define __FORCE_DEBUG__
//#define __FORCE_INFO__
#define THIS_FILE "nornn_convoy\fn_restart.sqf"
#include <core_macros.h>

TRACE_1("Start",_this);
TMFPROFILERSTART;

private ["_markerArray","_convoyArray","_groups","_restartConvoy","_onboardUnits","_group","_units","_vcl","_unit","_vclPosMrkr","_vclPosMrkrPos","_wp","_wp1","_wp2",
		 "_loop","_x","_role_arr","_role","_timeout"];
// Passed vars
_markerArray  	= _this select 0;
_convoyArray  	= _this select 1;
_groups		  	= _this select 2;
_restartConvoy	= _this select 3;
// Other vars
_onboardUnits	= [];
// Set behaviour chilled
{_x setBehaviour "SAFE"}forEach _groups;
// Foot units return to their vehicles
#ifdef __FORCE_DEBUG__
hintSilent "Rejoin convoy";
#endif
for "_loop" from 0 to ((count _groups) - 1) step 1 do {
	_group = _groups select _loop;
	if (count units _group > 0) then {
		_units = units _group;
		{doStop _x}forEach _units;
		sleep 1;
		_unit = (units _group) select 0;
		_vcl = _unit getVariable [QGVAR(VclPos),(assignedVehicle _unit)];
		TRACE_1("Units",ARR_2(_units,_vcl));
		if (!(isNull _vcl) && {canMove _vcl}) then {
			_vcl lockDriver false;
			_vclPosMrkr = createMarkerLocal [format ["mrkr_%1",_vcl],getPos _vcl];
			_vclPosMrkr setMarkerTypeLocal "Empty"; 
			_vclPosMrkrPos = getMarkerPos _vclPosMrkr;
			{ deleteWaypoint _x;
			} foreach (waypoints _group);
			_wp = _group addWayPoint [_vclPosMrkrPos,20];
			_wp setWaypointType "MOVE";
			_wp setWaypointSpeed "FULL"; 
			_wp1 = _group addWayPoint [_vclPosMrkrPos,20];
			_wp1 setWaypointType "GETIN NEAREST";
			_wp1 setWaypointSpeed "FULL"; 
			_wp2 = _group addWayPoint [_vclPosMrkrPos,20];
			_wp2 setWaypointType "HOLD";
			_wp2 setWaypointSpeed "LIMITED";
			{
				if (alive _x and canMove _x) then {
					_onboardUnits = _onboardUnits + [_x];
					_role_arr =  _x getVariable [QGVAR(VclRole), (assignedVehicleRole _x)];
					_role = "CARGO";
					if (count _role_arr > 0) then { _role = toUpper(_role_arr select 0); };
					switch(_role) do {
						case "DRIVER": { _x assignAsDriver _vcl; };
						case "TURRET": { _x assignAsTurret [_vcl,(_role_arr select 1)]; };
						case "COMMANDER": { _x assignAsCommander _vcl; };
						default { _x assignAsCargo _vcl; };
					};
				};
			}forEach _units;
			_units allowGetIn true;
			sleep 0.1;
			_units orderGetIn true;
		};
	};
	sleep 0.1;
};
#ifdef __FORCE_DEBUG__
hintSilent "";
#endif
_c = count _onboardUnits;
TRACE_1("Onboard",ARR_2(_c,_onboardUnits));
if (_c > 0) then {
	// WaitUntil all units have boarded
	_timeout = time + 200;
	while {_c > 0 && _timeout > time} do {
		_c = 0;
		{if (vehicle _x == _x) then {_c = _c + 1}} forEach _onboardUnits;
		{doStop _x; _x setSpeedMode "LIMITED"} forEach _convoyArray;
		sleep 3;
	};
	{
		if (vehicle _x == _x) then {
			_vcl = _x getVariable [QGVAR(VclPos),objNull];
			_role_arr =  _x getVariable [QGVAR(VclRole), (assignedVehicleRole _x)];
			_role = "CARGO";
			if (count _role_arr > 0) then { _role = toUpper(_role_arr select 0); };
			TRACE_1("Force boarding",ARR_3(_vcl,_x,_role_arr));
			switch(_role) do {
				case "DRIVER": { _x moveInDriver _vcl; };
				case "TURRET": { _x moveInTurret  [_vcl,(_role_arr select 1)]; };
				case "COMMANDER": { _x moveInCommander _vcl; };
				default { _x moveInCargo _vcl; };
			};
		};
	} forEach _onboardUnits;
};
TRACE("Ended Boarding");

for "_loop" from 0 to ((count _convoyArray) - 1) step 1 do {
	_vcl = _convoyArray select _loop;
	TRACE_1("Checking Vehicles",ARR_2(_vcl,driver _vcl));
	if (isNull (driver _vcl) && {alive _vcl} && {(count crew _vcl) > 0}) then {
		_unit = ((crew _vcl) select 0);
		_unit assignAsDriver _vcl;
		_unit moveInDriver _vcl;
		TRACE_1("Assign Missing Driver",ARR_2(_vcl,_unit));
		sleep 0.5;
	};
	if (isNull (driver _vcl) || {!(canMove _vcl)}) then {
		_convoyArray set [_loop, "XxDelxX"];
		TRACE_1("Remove Empty or Invalid Vec",ARR_2(_vcl,(canMove _vcl)));
	};
};
_convoyArray = _convoyArray - ["XxDelxX"];
#ifdef __FORCE_DEBUG__
hintSilent "Move out";
#endif
TRACE("Start Moving");

// If vehicles still alive then restart convoy 
if (count _convoyArray > 0) then {	
	[_markerArray,_convoyArray,_restartConvoy] spawn FUNC(Move);
};
sleep 5;
#ifdef __FORCE_DEBUG__
hintSilent "";
#endif

TRACE("End");
TMFPROFILERSTOP;