/*
Name: openConversation
Author: IndeedPete
Purpose: Opens a conversation (dialog) from config.
----------
Parameters:
_first - OBJECT: The first conversation participant saying every EVEN sentence. - player
_second - OBJECT: The second conversation participant saying every ODD sentence.  - MyInterestingConversationPartner
_conversation - STRING: The config entry referring to the desired conversation. - "MyFirstConversation"
----------
Requires:
Dialog "IP_DLG_CONVERSATION"
.jpg - "img\defaultAvatar.jpg"
*/
if (isDedicated || !hasInterface) exitWith {};
private ["_first", "_second", "_str", "_sentences", "_responses", "_expression","_conversation","_handle","_picture","_i"
		,"_text","_sentence","_index","_hiddenData","_condition"];_getArguments = {
	private "_arguments";
	
	_arguments = (missionConfigFile >> "Conversations" >> _this >> "arguments");
	if ((isArray _arguments) && {count(getArray _arguments) > 0}) then {
		_arguments = getArray _arguments;
		for "_i" from 0 to ((count _arguments) - 1) do {
			_arguments set [_i, (call compile (_arguments select _i))];
		};
	} else {
		_arguments = [];
	};
	
	_arguments
}; 

_first = [_this, 0, objNull, [objNull]] call BIS_fnc_param;
_second = [_this, 1, objNull, [objNull]] call BIS_fnc_param;
_conversation = [_this, 2, "", [""]] call BIS_fnc_param;

_handle = createDialog "IP_DLG_CONVERSATION";
_picture = _first getVariable ["IP_Avatar", "tmf\support\modules\ip_conv\pics\defaultAvatar.jpg"];
ctrlSetText [1200, _picture];
_picture = _second getVariable ["IP_Avatar", "tmf\support\modules\ip_conv\pics\defaultAvatar.jpg"];
ctrlSetText [1201, _picture];

_str = "";
_sentences = getArray(missionConfigFile >> "Conversations" >> _conversation >> "sentences");
if (count _sentences == 0) exitWith {call IP_fnc_closeConversation; hint "IP_fnc_openDialog\nConversation " + str(_conversation) + " has no sentences!";};
for "_i" from 0 to ((count _sentences) - 1) do {
	if (_i mod 2 == 0) then {
		_str = _str + "<t align='left'>" + (name _first) + ": " + (_sentences select _i) + "</t><br/><br/>";
	} else {
		_str = _str + "<t align='right'>" + (name _second) + ": " + (_sentences select _i) + "</t><br/><br/>";
	};
};

_arguments = _conversation call _getArguments;
_str = format ([_str] + _arguments);

player createDiarySubject ["ConvLog", localize "STR_CONV_LOG"];
player createDiaryRecord ["ConvLog", [(name _second), _str]];
_text = parseText _str;
((findDisplay 20001) displayCtrl 1100) ctrlSetStructuredText _text;

_responses = (missionConfigFile >> "Conversations" >> _conversation >> "responses");
if ((isArray _responses) && {count (getArray _responses) > 0}) then {
	_responses = getArray _responses;
	_i = 0;
	{
		_condition = (missionConfigFile >> "Conversations" >> _x >> "condition");
		if ((!isText _condition) OR {((getText _condition) == "") OR {call compile (getText _condition)}}) then {
			_arguments = _x call _getArguments;
			_sentence = str(_i + 1) + ". " + format ([((getArray(missionConfigFile >> "Conversations" >> _x >> "sentences")) select 0)] + _arguments);
			_index = lbAdd [1500, _sentence];
			if (isplayer _first && vehicleVarName _first == "") then {
				_hiddenData = "[player, " + str(_second) + ", '" + _x + "']";
			} else {
				_hiddenData = "[" + str(_first) + ", " + str(_second) + ", '" + _x + "']";
			};
			lbSetData [1500, _index, _hiddenData];
			_i = _i + 1;
		};
	} forEach _responses;
};

_expression = (missionConfigFile >> "Conversations" >> _conversation >> "expression");
if (isText _expression) then {
	_expression = getText _expression;
	if (_expression != "") then {
		[_first, _second, _conversation] spawn (compile _expression);
	}; 
};