#define THIS_FILE "vehrespawn.sqf"
#include <tmf\tmf_constants.h>
#include <tmf\tmf_macros.h>
WAITINIT(vehrespawn);

// ex: nul = [this, 300] execVM "vehrespawn.sqf"; // respawns after 300 seconds empty
// ex: nul = [this] execVM "vehrespawn.sqf"; // respawns when destroyed or disabled only

if (isServer) then {
	private ["_unit","_respawn_timer","_unit_type","_init_pos","_init_dir","_time_empty","_pos"];
	_unit = _this;
	_respawn_timer = 0;
	_time_empty = 0;
	if (typename _this == typename []) then {
		_unit = _this select 0;
		if (count _this > 1) then { _respawn_timer = _this select 1; };
	};
	_unit setVariable ["respawn_timer",_respawn_timer];
	_unit addEventHandler ["GetIn",{_vec = _this select 0; _timer = _vec getVariable "respawn_timer"; _unit = _this select 2; if (_timer > 0) then { ["d_msg",[["STR_RESPAWN_VEC_TIMER",_timer],"unit",_unit,"global"]  ] call XNetCallEvent; } else { ["d_msg",[["STR_RESPAWN_VEC",_timer],"unit",_unit,"global"]  ] call XNetCallEvent; };}];
	_init_pos = getPos _unit;
	_init_dir = getDir _unit;
	_unit_type = typeof _unit;
	_unit_variable_name = vehicleVarName _unit;
	while {true} do {
		if (!alive _unit || {!(canMove _unit)}) then {
			sleep 10;
			// We check there are no nearby players
			if (isNull _unit || {({isPlayer _x} count (_unit nearEntities ["CaManBase", 50])) <= 0}) then {
				// diag_log format["Respawning Destroyed Unit: %1",_unit_type];
				if (!isnull _unit) then { deleteVehicle _unit; };
				_unit = _unit_type createVehicle _init_pos;
				_unit setDir _init_dir;
				missionNameSpace setVariable [_unit_variable_name, _unit];
				_unit setVehicleVarName _unit_variable_name;
				_unit setVariable ["respawn_timer",_respawn_timer];
				_unit addEventHandler ["GetIn",{_vec = _this select 0; _timer = _vec getVariable "respawn_timer"; _unit = _this select 2; if (_timer > 0) then { ["d_msg",[["STR_RESPAWN_VEC_TIMER",_timer],"unit",_unit,"global"]  ] call XNetCallEvent; } else { ["d_msg",[["STR_RESPAWN_VEC",_timer],"unit",_unit,"global"]  ] call XNetCallEvent; };}];
				// We do nothing for the next 20 minutes
				sleep 1223.456;
			};
		} else {
			if (_respawn_timer > 0 && {(_unit distance _init_pos) > 100}) then {
				if (_time_empty > 0) then {
					if (count (crew _unit) > 0) then {
						_time_empty = 0;
					} else {
						if ((time - _time_empty) > _respawn_timer) then {
							if (({isPlayer _x} count (_unit nearEntities ["CaManBase", 50])) <= 0) then {
								// diag_log format["Respawning Empty Unit: %1 (%2)",_unit_type, time];
								if (damage _unit > 0.4) then {
									_unit setPos [0,0,0];
									_unit setDamage 1;
								} else {
									_pos = _init_pos findEmptyPosition [0,40,_unit_type];
									if (count _pos < 3) then {
										_pos = _init_pos;
									};
									_unit setPos _pos;
									_unit setDir _init_dir;
								};
								// We do nothing for the next 20 minutes
								sleep 1223.456;
							};
						};
					};
				} else {
					if (count (crew _unit) <= 0) then {
						// diag_log format["Detected Empty Unit: %1 (%2)",_unit_type, time];
						_time_empty = time;
					} else {
						_time_empty = 0;
					};
				};
			};
		};
		sleep (30 + random (30));
	};
};